<?php

/**
 * class.ODBC.php
 * --------------
 * @version 5.4.0
 * @copyright 2002-2010 Melbis Company
 * @link http://www.melbis.com
 * @author Dmitriy Kasyanov
 **/

/** 
 * Class ODBC
 * Operate with ODBC database via php functions
 **/
class ODBC
{
 
 	/** 
 	 * Vars
 	 **/
 	var $gCallFile;
	var $gCallLine;
	var $gConnect;
	
 	/**
     * Constructor
     **/
 	function ODBC($mCallFile, $mCallLine, $mDNS, $mUserName, $mUserPass)
	{
		$this->gCallFile = $mCallFile;
		$this->gCallLine = $mCallLine;
		$this->gConnect=@odbc_connect($mDNS, $mUserName, $mUserPass);
		$this->TestForErrors();
 	}
	
	/**
	 * DoQuery
	 **/
	function DoQuery($mCallLine, $mCommand='')
	{
		$this->gCallLine = $mCallLine;
		$result=@odbc_exec($this->gConnect, $mCommand);
		$this->TestForErrors();
		return $result;	
	}
	
	/**
	 * GetNumRows
	 **/
	function GetNumRows($mQuery)
	{
		if ($num_rows = @odbc_num_rows($mQuery) < 0) 
		{
 			$num_rows = 0;
			@odbc_fetch_row($mQuery, 0);
			while (@odbc_fetch_row($mQuery))
			{
  				$num_rows++;
			}
			@odbc_fetch_row($mQuery, 0);
		}
		$this->TestForErrors();
		return $num_rows;
	}
	
	/**
	 * GetNumFields
	 **/
	function GetNumFields($mQuery)
	{
		$num_fields = @odbc_num_fields($mQuery);
		$this->TestForErrors();
		return $num_fields;
	}
	
	/**
	 * GetFieldName
	 **/
	function GetFieldName($mQuery, $mColNum)
	{
		$field_name = @odbc_field_name($mQuery, $mColNum + 1);	
		$this->TestForErrors();
		return $field_name;
	}
	
	/**
	 * FetchHash
	 **/
	function FetchHash($mQuery)
	{
		/*
		$fields = @odbc_num_fields($mQuery);
		for ( $i = 1; $i <= $fields; $i++ )
		{
			@odbc_fetch_row($mQuery);
			$hash[@odbc_field_name($mQuery, $i)] = @odbc_result($mQuery, $i);
		} 
		*/
		$hash = @odbc_fetch_array($mQuery);
		$this->TestForErrors();
		return $hash;
	}
	
	/**
	 * FetchRow
	 **/
	function FetchRow($mQuery)
	{
		/*
		$fields = @odbc_num_fields($mQuery);
		@odbc_fetch_row($mQuery);
		for ( $i = 1; $i <= $fields; $i++ )
		{
			$hash[$i-1] = @odbc_result($mQuery, $i);
		} 
		*/
		$rc = @odbc_fetch_into($mQuery, $hash);
		$this->TestForErrors();
		return $hash;
	}
	
	/**
	 * DataSeek
	 **/
	function DataSeek($mQuery, $mPos)
	{
		@odbc_fetch_row($mQuery, $mPos);
		$this->TestForErrors();
		return TRUE;
	}

	/**
	 * TestForErrors
	 **/
	function TestForErrors()
	{
		if (strlen(odbc_errormsg()) > 0) 
		{
			echo 'SQL_ERROR: '.$this->gCallFile.'['.$this->gCallLine.']::'.odbc_errormsg();
			exit;
		}
	}
	
}

?>