<?php

/**
 * clients.php
 * -----------
 * @version 5.4.0
 * @copyright 2002-2010 Melbis Company
 * @link http://www.melbis.com
 * @author Dmitriy Kasyanov
 **/

// Define script folder 
define('FOLDER', './../');

 
// Require classes and includes
require_once('./privat/privat.php');
require_once('./includes/common.php');
require_once('./includes/admin.php');
require_once('./class/show/class.XML.php');
require_once('./class/util/class.PclZip.php');

// Set time limit 
@set_time_limit(300); 

// Start session
session_start();

// Connect to Data
$gData = data_connect(true);

// What you need?
switch ($_POST['command'])
{
	case 'GET_ALL_CLIENTS' : 
		get_clients(false); 
		break;
	case 'SEARCH_CLIENTS' : 
		get_clients(true); 
		break;
	case 'SAVE_CLIENT_PARAM' : 
		save_client_param(); 
		break;
	default : 
		echo "PHP_ERROR: Unknow command in line [".__LINE__."] :: Fail Command";
}

/**
 * Function get_clients
 * Return clients and their fields
 **/
function get_clients($mSearch)
{
	global $gData;
	
	// Prepare if do search
	if ( $mSearch ) 
	{
		$vars = explode('&', zip_file_to_string($_FILES['string_file']['tmp_name']));
		foreach ($vars as $var)
		{
			list($key, $value) = explode('=', $var);
			$input[$key] = urldecode($value);
		}
	}

	// Start XML file
	$xml_file = './tmp/'.md5(session_id()).'.xml';
	$xml = new XML(SHOP_CHARSET, $xml_file);
	$xml->StartTag('MELBISSHOP');
		
	// Parse client
	$clients = $gData->GetAllClients($input);
	$rows = $gData->GetNumRows($clients);
	$how = ( $rows > 500 ) ? 500 : $rows;
	$xml->StartTag('CLIENTS', array('total' => $rows, 'transfer' => $how));
	for ( $i = 1; $i <= $how; $i++ ) 
	{	
		$client = $gData->FetchHash($clients);
		unset($client['charset']);
		$xml->PutTag('CLIENT', $client);		
	}
	$xml->CloseTag('CLIENTS');
	
	// Parse client fields
	$gData->DataSeek($clients, 0);
	$xml->StartTag('CLIENTFIELD');
	for ( $i = 1; $i <= $how; $i++ ) 
	{	
		$client = $gData->FetchHash($clients);

		$field = $gData->GetClientData($client['id']);
		$field_rows = $gData->GetNumRows($field);
		
		for ( $n = 1; $n <= $field_rows; $n++ ) 
		{	
			$hash = $gData->FetchHash($field);
			( $hash['isfolder'] != 1 ) ? $dot = ' ' : $dot = '';
			$hash['name'] = str_repeat('    ', $hash['tlevel']).$dot.$hash['name'];
			$hash['client_id'] = $client['id'];
			unset($hash['descr']);
			unset($hash['tlevel']);
			unset($hash['tindex']);
			unset($hash['need']);
			$xml->PutTag('FIELD', $hash);
		}
	}
	$xml->CloseTag('CLIENTFIELD');
	
	
	$xml->CloseTag('MELBISSHOP');
	$xml->Free();
	
	// Put result to archive
	xml_to_zip_answer($xml_file);	
}

/**
 * Function save_client_param
 * Move orders to archive
 **/
function save_client_param()
{
	global $gData;
	
	
	$client_list = explode(';', trim(zip_file_to_string($_FILES['string_file']['tmp_name']), ';'));
	foreach ( $client_list as $client_code) 
	{	
		$param = explode('|', $client_code);
		$reg_date = explode('.', $param[7]);
		$last_date = explode('.', $param[8]);
		if ( $param[1] == 2 )
		{
			// Remove client
			$gData->RemoveClient(addslashes($param[0]));
		}
		else 
		{ 
			// Update client info
			$gData->SaveClientParams(addslashes($param[0]),
									 addslashes(str_replace(',','.',$param[2])),
									 addslashes(str_replace(',','.',$param[3])),
									 addslashes($param[4]),
									 addslashes(str_replace(',','.',$param[5])),
									 addslashes($param[6]),
									 addslashes($reg_date[2].'-'.$reg_date[1].'-'.$reg_date[0]),
									 addslashes($last_date[2].'-'.$last_date[1].'-'.$last_date[0])
									 );
		}
	}
	
	echo "QUERY_EXECUTE";
}


?>