<?php

/**
 * partner.php
 * -----------
 * @version 5.4.0
 * @copyright 2002-2010 Melbis Company
 * @link http://www.melbis.com
 * @author Dmitriy Kasyanov
 **/

// Define script folder 
define('FOLDER', './../');
 
// Require classes and includes
require_once('./privat/privat.php');
require_once('./includes/common.php');
require_once('./includes/admin.php');
require_once('./class/show/class.XML.php');
require_once('./class/util/class.PclZip.php');
require_once('./class/util/class.Emailer.php');
require_once('./class/show/class.FastTemplate.php');


// Set time limit 
@set_time_limit(300); 

// Start session
session_start();

// Connect to Data
$gData = data_connect(true);

// What you need?
switch ($_POST['command'])
{
	case 'GET_COMMENT' : 
		get_comment(); 
		break;
	case 'ADD_COMMENT' : 
		add_comment(); 
		break;		
	case 'SAVE_COMMENT' : 
		save_comment(); 
		break;		
	case 'ADD_BLOCK_IP' : 
		add_block_ip(); 
		break;		
	case 'GET_COMMENT_BLOCK' : 
		get_comment_block(); 
		break;			
	case 'DEL_COMMENT_BLOCK' : 
		del_comment_block(); 
		break;		
	default : 
		echo "PHP_ERROR: Unknow command in line [".__LINE__."] :: Fail Command";
}

/**
 * Function get_comment
 * Return comment data
 **/
function get_comment()
{
	global $gData;
	
	$vars = explode('&', $_POST['values']);
	foreach ($vars as $var)
	{
		list($key, $value) = explode('=', $var);
		$input[$key] = urldecode($value);
	}
	
	// Start XML file
	$xml_file = './tmp/'.md5(session_id()).'.xml';
	$xml = new XML(SHOP_CHARSET, $xml_file);
	$xml->StartTag('MELBISSHOP', array('Version' => 'Melbis Shop v'.SCRIPT_VERSION));
		
	// Request comment
	if ( $input['goods_id'] != 0 )
	{
		$comment = $gData->GetGoodsComment($input['goods_id']);
	}
	else 
	{
		$comment = $gData->GetAllCommentFromDate(make_date(-86400*$input['last_days']));
	}
	$rows = $gData->GetNumRows($comment);
	$how = ( $rows > 1000 ) ? 1000 : $rows;
	$xml->StartTag('COMMENT', array('total' => $rows, 'transfer' => $how));
	for ( $i = 1; $i <= $how; $i++ ) 
	{		
		$hash = $gData->FetchHash($comment);
		$hash['ip'] = long2ip($hash['ip']);
		$xml->PutTag('ITEM', $hash);
	}
	$xml->CloseTag('COMMENT');
	$xml->CloseTag('MELBISSHOP');
	$xml->Free();
	
	// Put result to archive
	xml_to_zip_answer($xml_file);
}

/**
 * Function add_comment
 * Add new comment
 **/
function add_comment()
{
	global $gData;
	
	$vars = explode('&', zip_file_to_string($_FILES['string_file']['tmp_name']));
	foreach ($vars as $var)
	{
		list($key, $value) = explode('=', $var);
		$input[$key] = urldecode($value);
	}
	
	$gData->AddComment($input['store_id'], 
					   get_now(), 
					   addslashes($input['name']), 
					   addslashes($input['email']),  
					   addslashes($input['mess_text']), 
					   $input['set_voice']*1, 
					   sprintf("%u\n", ip2long(user_ip()))
					   );
	
	echo "QUERY_EXECUTE";
}

/**
 * Function save_comment
 * Save comments update
 **/
function save_comment()
{
	global $gData;
	
	$comment_list = explode(';', trim(zip_file_to_string($_FILES['string_file']['tmp_name']), ';'));
	foreach ( $comment_list as $comment_code) 
	{	
		$comment = explode('|', $comment_code);
		if ( $comment[1] == 2 )
		{
			// Remove comment
			$gData->RemoveComment($comment[0]);
		}
		else 
		{ 
			// Update Comment
			$gData->UpdateComment($comment[0], addslashes($comment[2]), addslashes($comment[3]), addslashes($comment[4]), $comment[5]);
		}
	}
	
	echo "QUERY_EXECUTE";
}

/**
 * Function get_comment_block
 * Return comment data
 **/
function get_comment_block()
{
	global $gData;
	
	// Start XML file
	$xml_file = './tmp/'.md5(session_id()).'.xml';
	$xml = new XML(SHOP_CHARSET, $xml_file);
	$xml->StartTag('MELBISSHOP', array('Version' => 'Melbis Shop v'.SCRIPT_VERSION));
		
	$list = $gData->GetCommentBlock();
	$rows = $gData->GetNumRows($list);
	$xml->StartTag('BLOCKLIST', array('total' => $rows, 'transfer' => $rows));
	for ( $i = 1; $i <= $rows; $i++ ) 
	{		
		$hash = $gData->FetchHash($list);
		$hash['ip'] = long2ip($hash['ip']);
		$xml->PutTag('ITEM', $hash);
	}
	$xml->CloseTag('BLOCKLIST');
	$xml->CloseTag('MELBISSHOP');
	$xml->Free();
	
	// Put result to archive
	xml_to_zip_answer($xml_file);
}

/**
 * Function add_block_ip
 * Add new blocked ip
 **/
function add_block_ip()
{
	global $gData;
	
	$gData->AddCommentBlock(sprintf("%u\n", ip2long($_POST['values'])), get_now());
	
	echo "QUERY_EXECUTE";
}

/**
 * Function del_comment_block
 * Delete comment block ip
 **/
function del_comment_block()
{
	global $gData;
	
	$list_ip = explode(';', trim(zip_file_to_string($_FILES['string_file']['tmp_name']), ';'));
	foreach ( $list_ip as $ip) 
	{	
		$gData->RemoveCommentBlock(sprintf("%u\n", ip2long($ip)));

	}
	
	echo "QUERY_EXECUTE";
}

?>