<?php

/**
 * dayly.php
 * ---------
 * @version 5.4.0
 * @copyright 2002-2010 Melbis Company
 * @link http://www.melbis.com
 * @author Dmitriy Kasyanov
 **/
 
// Require classes and includes
$script_path = ( strlen($_SERVER['PATH_TRANSLATED']) > 0 ) ? $_SERVER['PATH_TRANSLATED'] : $_SERVER['SCRIPT_FILENAME'];
if ( realpath(dirname($script_path).'/../privat/privat.php') === false || strlen($script_path) == 0 ) 
{
	$script_path = $_SERVER['argv'][0];
	if ( realpath(dirname($script_path).'/../privat/privat.php') === false ) die('Error: cannot define script path');
}
require_once(realpath(dirname($script_path).'/../privat/privat.php'));
require_once(SHOP_CWD.'/admin/includes/common.php');



// Set time limit 
@set_time_limit(3000); 

// Define variables
define('MAX_PARTNER_PAY_IN_DAY', 100);


// Go
main();

/**
 * Function main
 **/
function main()
{
	global $gData, $gOptions, $gTpl, $gMessage, $gStartPoint;
	
	// Get start point for time
	$gStartPoint = run_time(0);
	
	// Connect to Data 
	$gData = data_connect(true);	


	// Clear old statistic
	$gData->ClearStat(make_date(-86400*2, "Y-m-d"), 
					  make_date(-86400*31, "Y-m-d"), 
					  make_date(-86400*366, "Y-m-d"), 
					  make_date(-86400*$gOptions['cron_common_stat'], "Y-m-d")
					  );
	
	// Clear old clients
	$client = $gData->GetOldClient(make_date(-86400*$gOptions['cron_buyer'], "Y-m-d"));
	$rows = $gData->GetNumRows($client);
	for ( $i = 1; $i <= $rows; $i++ )
	{
		$hash = $gData->FetchRow($client);
		$gData->ClearOldClient($hash[0]);
	}
	
	// Clear old orders from archive
	$order = $gData->GetOldArchOrder(make_date(-86400*$gOptions['cron_archiv_order'], "Y-m-d"));
	$rows = $gData->GetNumRows($order);
	for ( $i = 1; $i <= $rows; $i++ )
	{
		$hash = $gData->FetchRow($order);
		$gData->ClearOldArchOrder($hash[0]);
	}
	
	// Clear old remembers (one year ago)
	$gData->ClearOldRemember(make_date(-86400*365));	
	
	// Analize archive tables and client fields for error
	$goods = $gData->GetGhostArchGoods();
	$rows = $gData->GetNumRows($goods);
	for ( $i = 1; $i <= $rows; $i++ )
	{
		$hash = $gData->FetchHash($goods);
		$gData->RemoveArchiveOrder($hash['order_id']);
	}
	$client = $gData->GetGhostArchClient();
	$rows = $gData->GetNumRows($client);
	for ( $i = 1; $i <= $rows; $i++ )
	{
		$hash = $gData->FetchHash($client);
		$gData->RemoveArchiveOrder($hash['order_id']);
	}
	$client = $gData->GetGhostClientField();
	$rows = $gData->GetNumRows($client);
	for ( $i = 1; $i <= $rows; $i++ )
	{
		$hash = $gData->FetchHash($client);
		$gData->ClearOldClient($hash['client_id']);
	}
	
	// Clear subscribers of not exists news
	$news = $gData->GetGhostNews();
	$rows = $gData->GetNumRows($news);
	for ( $i = 1; $i <= $rows; $i++ )
	{
		$hash = $gData->FetchRow($news);
		$gData->ClearSubscriber($hash[0]);
	}	
	
	// Clear vote pool for old voting
	$vote = $gData->GetGhostVote();
	$rows = $gData->GetNumRows($vote);
	for ( $i = 1; $i <= $rows; $i++ )
	{
		$hash = $gData->FetchRow($vote);
		$gData->ClearVotePool($hash[0]);
	}
	
	// Save partner common statistic
	$gData->SavePartnerStatCommon(make_date(-86400, "Y-m-d"));
	
	// Pay partner for clicks
	$click_buy = $gData->GetPartnerClickList();
	$rows = $gData->GetNumRows($click_buy);
	if ( $rows > 0 ) 
	{ 
		$rules = $gData->GetPartnerMain();
		$ismonth = make_date(-(31+$rules['how_day_wait'])*86400, "Y-m").'-01';
		$partner = $gData->GetPartnerNeedPayClick(MAX_PARTNER_PAY_IN_DAY, $ismonth, ($rules['work_type'] == 0) );
		$part_rows = $gData->GetNumRows($partner);
		for ( $n = 1; $n <= $part_rows; $n++ ) 
		{		
			$hash = $gData->FetchHash($partner);
			list ($pay_sum, $how_orders) = $gData->GetPartnerOrdersCount($hash['partner_id'], $hash['ismonth'], $hash['click_accept']);
			if ( $pay_sum > 0)
			{
				$notice = sprintf($gMessage['part_pay_click'], 
								  date($gOptions['main_fmt_date'], 
								  strtotime($ismonth)), 
								  $hash['click_accept'], 
								  $how_orders,
								  number_format($hash['mult_click']*100, 0, "," ,"'")
								  );
				$gData->AddPartnerAccount($hash['partner_id'], 
										  get_now(), 
										  0, 
										  $pay_sum*$hash['mult_click'], 
										  addslashes($notice)
										  );
			}
			$gData->FixPartnerPay($hash['partner_id'], $ismonth);
		}
	}
	
	// Clear partner statistic
	$rules = $gData->GetPartnerMain();
	$gData->ClearPartnerStat(make_date(-86400*$rules['stat_full_days'], "Y-m-d"),
							 make_date(-86400*$rules['stat_days'], "Y-m-d"),
							 make_date(-86400*30*$rules['stat_month'], "Y-m-d"),
							 make_date(-86400*$rules['no_active_days'], "Y-m-d"),
							 make_date(-86400*30*12*$rules['save_account_years'], "Y-m-d")
							 );	
		
	// Analize partner tables for error
	$tables = array('partner_stat', 'partner_stat_days', 'partner_stat_month', 'partner_account');
	foreach ($tables as $table )
	{
		$part = $gData->GetGhostPartInfo($table);
		$rows = $gData->GetNumRows($part);
		for ( $i = 1; $i <= $rows; $i++ )
		{
			$hash = $gData->FetchRow($part);
			$gData->ClearPartnerInfo($table, $hash[0]);
		}							 
	}
	
	// Clear goods comments
	$goods = $gData->GetGhostComment();
	$rows = $gData->GetNumRows($goods);
	for ( $i = 1; $i <= $rows; $i++ )
	{
		$hash = $gData->FetchRow($part);
		$gData->ClearComment($hash[0]);
	}		

	// Clear temporary folder
	$handle = opendir(SHOP_CWD.'/admin/tmp');
	clearstatcache();
	while ( $file = readdir($handle) )
	{ 
		if ( $file != "." && $file != ".." )
		{ 
			$info = pathinfo(SHOP_CWD.'/admin/tmp/'.$file);
			if ( $info['extension'] == 'xml' )
			{
				$modify_time = date("U") - filemtime(SHOP_CWD.'/admin/tmp/'.$file);
				if ( $modify_time > 24*3600 )
				{
					@unlink(SHOP_CWD.'/admin/tmp/'.$file);
				}
			}
		}
	}
	closedir($handle);	
	
	// Echo page compilate time
	$gEndPoint = run_time($gStartPoint);
	echo_page_time($gEndPoint);	
}

?>