<?php

/**
 * news_send.php
 * -------------
 * @version 5.4.0
 * @copyright 2002-2010 Melbis Company
 * @link http://www.melbis.com
 * @author Dmitriy Kasyanov
 **/
 
// Require classes and includes
$script_path = ( strlen($_SERVER['PATH_TRANSLATED']) > 0 ) ? $_SERVER['PATH_TRANSLATED'] : $_SERVER['SCRIPT_FILENAME'];
if ( realpath(dirname($script_path).'/../privat/privat.php') === false || strlen($script_path) == 0 ) 
{
	$script_path = $_SERVER['argv'][0];
	if ( realpath(dirname($script_path).'/../privat/privat.php') === false ) die('Error: cannot define script path');
}
require_once(realpath(dirname($script_path).'/../privat/privat.php'));
require_once(SHOP_CWD.'/admin/includes/common.php');
require_once(SHOP_CWD.'/admin/class/show/class.FastTemplate.php');
require_once(SHOP_CWD.'/admin/class/util/class.Emailer.php');

// Set time limit 
@set_time_limit(3000); 

// Go
main();

/**
 * Function main
 **/
function main()
{
	global $gData, $gOptions, $gTpl, $gStartPoint;
	
	// Get start point for time
	$gStartPoint = run_time(0);
	
	// Connect to Data 
	$gData = data_connect(true);	

	// Init vars
	$url = rtrim($gOptions['attr_base_url'], '/');
	
	// Send new manual news
	$news = $gData->GetNewsForMail(make_date(-86400));
	$rows = $gData->GetNumRows($news);
	for ( $i = 1; $i <= $rows; $i++ )
	{
		$hash = $gData->FetchHash($news);
		// Manual news
		if ( strlen($hash['cont_id']) > 0 )
		{
			$mail_list = $gData->GetNewsEmailList($hash['id'], ($hash['for_buyer'] == 1));
			$content = ( strlen($hash['content']) > 0 ) ? $hash['content'] : $hash['descr'];
			$content = str_replace('src="', 'src="'.$url.'/', $content);
			$path_info = pathinfo($hash['attach']);
			$attach = ( strlen($hash['attach']) > 0 ) ? SHOP_CWD.'/files/news_attach'.$hash['cont_id'].'.'.$path_info['extension'] : '';
			send_news_mails($mail_list, 
							$hash['date_time'], 
							$hash['name'], 
							$hash['cont_name'], 
							$content, 
							$attach, 
							$hash['attach'],
							$hash['ishtml']
							);
		}
		// Auto news
		switch ( $hash['isperiod'] )
		{
			case '0' :
				$allow = true;
				break;
			case '1' :
				$allow = ( get_now('w') == 1 ); // day of the week, numeric, i.e. "0" (Sunday) to "6" (Saturday)
				break;
			case '2' :
				$allow = ( get_now('j') == 1 ); // day of the month without leading zeros; i.e. "1" to "31" 
				break;
		}
		if ( $hash['istype'] > 0 && $allow )
		{
			// Make content
			$content = '';
			$attach = '';
			$temp_type = ( $hash['ishtml'] == 1 ) ? 'html' : 'text';
			switch ( $hash['istype'] )
			{
				case '1' :
					// Price list
					$content = @implode('',@file(SHOP_CWD.'/'.TEMPLATES.'/_news/mails/auto/'.$temp_type.'/price.htm'));
					$attach = SHOP_CWD.'/files/price.zip';
					break;
				case '2' :
					// Discount goods
					$tpl = new FastTemplate(SHOP_CWD.'/'.TEMPLATES.'/_news/mails/auto/'.$temp_type);
					$tpl->DefineTemplate(array('main'			=> 'goods_main.htm',
											   'unit'			=> 'goods_unit.htm',
											   'between_row'	=> 'goods_between.htm',
											   'type'			=> 'goods_discount.htm'
												));
					$goods = $gData->GetDiscountGoods(100);
					$goods_rows = $gData->GetNumRows($goods);
					if ( $goods_rows == 0 ) continue;
					for ( $n = 1; $n <= $goods_rows; $n++ ) 
					{
						$goods_hash = $gData->FetchRow($goods);
						if ( $n == $goods_rows ) $tpl->Assign('BETWEENROW', ''); 
						if ( is_file(SHOP_CWD.'/files/store'.$goods_hash[0].'.jpg') ) 
						{
		    				$img_file = $url.'/files/store'.$goods_hash[0].'.jpg';
						} 
						else
						{
							$img_file = $url.'/files/store_default.jpg';
						}
						$tpl->Assign(array('CODE'		=> ( $temp_type == 'html' ) ? htmlspecialchars($goods_hash[1]) : $goods_hash[1],
						                   'NAME'		=> ( $temp_type == 'html' ) ? htmlspecialchars($goods_hash[2]) : $goods_hash[2],
								   		   'NOTE'   	=> $goods_hash[3],
				   						   'PRICE'  	=> number_format($goods_hash[5], $gOptions['main_prec'], "," ,"'"),
							   			   'ICON'		=> $img_file,
							   			   'LINK'		=> $url."/goods.php?id=".$goods_hash[0]
					        	           ));
						$tpl->Parse('UNIT', '.unit'); 
					}
					$tpl->Parse('BETWEENROW', 'between_row'); 
					$tpl->Assign('CURR', ( $temp_type == 'html' ) ? htmlspecialchars($gOptions['main_base_curr']) : $gOptions['main_base_curr']); 
					$tpl->Parse('TYPE', 'type');
					$tpl->Parse('MAIN', 'main');
					$content = $tpl->Fetch('MAIN');
					break;
				case '3' :
					// Hit goods
					$tpl = new FastTemplate(SHOP_CWD.'/'.TEMPLATES.'/_news/mails/auto/'.$temp_type);
					$tpl->DefineTemplate(array('main'			=> 'goods_main.htm',
											   'unit'			=> 'goods_unit.htm',
											   'between_row'	=> 'goods_between.htm',
											   'type'			=> 'goods_hit.htm'
												));
					$goods = $gData->GetHitGoods(100);
					$goods_rows = $gData->GetNumRows($goods);
					if ( $goods_rows == 0 ) continue;
					for ( $n = 1; $n <= $goods_rows; $n++ ) 
					{
						$goods_hash = $gData->FetchRow($goods);
						if ( $n == $goods_rows ) $tpl->Assign('BETWEENROW', ''); 
						if ( is_file(SHOP_CWD.'/files/store'.$goods_hash[0].'.jpg') ) 
						{
		    				$img_file = $url.'/files/store'.$goods_hash[0].'.jpg';
						} 
						else
						{
							$img_file = $url.'/files/store_default.jpg';
						}
						$price = ( $goods_hash[5] > 0 ) ? $goods_hash[5] : $goods_hash[4]; 
						$tpl->Assign(array('CODE'		=> ( $temp_type == 'html' ) ? htmlspecialchars($goods_hash[1]) : $goods_hash[1],
						                   'NAME'		=> ( $temp_type == 'html' ) ? htmlspecialchars($goods_hash[2]) : $goods_hash[2],
								   		   'NOTE'   	=> $goods_hash[3],
				   						   'PRICE'  	=> number_format($price, $gOptions['main_prec'], "," ,"'"),
							   			   'ICON'		=> $img_file,
							   			   'LINK'		=> $url."/goods.php?id=".$goods_hash[0]
					        	           ));
						$tpl->Parse('UNIT', '.unit'); 
					}
					$tpl->Parse('BETWEENROW', 'between_row'); 
					$tpl->Assign('CURR', ( $temp_type == 'html' ) ? htmlspecialchars($gOptions['main_base_curr']) : $gOptions['main_base_curr']); 
					$tpl->Parse('TYPE', 'type');
					$tpl->Parse('MAIN', 'main');
					$content = $tpl->Fetch('MAIN');
					break;
				case '4' :
					// New goods
					$tpl = new FastTemplate(SHOP_CWD.'/'.TEMPLATES.'/_news/mails/auto/'.$temp_type);
					$tpl->DefineTemplate(array('main'			=> 'goods_main.htm',
											   'unit'			=> 'goods_unit.htm',
											   'between_row'	=> 'goods_between.htm',
											   'type'			=> 'goods_new.htm'
												));
					$goods = $gData->GetNewGoods(100);
					$goods_rows = $gData->GetNumRows($goods);
					if ( $goods_rows == 0 ) continue;
					for ( $n = 1; $n <= $goods_rows; $n++ ) 
					{
						$goods_hash = $gData->FetchRow($goods);
						if ( $n == $goods_rows ) $tpl->Assign('BETWEENROW', ''); 
						if ( is_file(SHOP_CWD.'/files/store'.$goods_hash[0].'.jpg') ) 
						{
		    				$img_file = $url.'/files/store'.$goods_hash[0].'.jpg';
						} 
						else
						{
							$img_file = $url.'/files/store_default.jpg';
						}
						$price = ( $goods_hash[5] > 0 ) ? $goods_hash[5] : $goods_hash[4]; 
						$tpl->Assign(array('CODE'		=> ( $temp_type == 'html' ) ? htmlspecialchars($goods_hash[1]) : $goods_hash[1],
						                   'NAME'		=> ( $temp_type == 'html' ) ? htmlspecialchars($goods_hash[2]) : $goods_hash[2],
								   		   'NOTE'   	=> $goods_hash[3],
				   						   'PRICE'  	=> number_format($price, $gOptions['main_prec'], "," ,"'"),
							   			   'ICON'		=> $img_file,
							   			   'LINK'		=> $url."/goods.php?id=".$goods_hash[0]
					        	           ));
						$tpl->Parse('UNIT', '.unit'); 
					}
					$tpl->Parse('BETWEENROW', 'between_row'); 
					$tpl->Assign('CURR', ( $temp_type == 'html' ) ? htmlspecialchars($gOptions['main_base_curr']) : $gOptions['main_base_curr']); 
					$tpl->Parse('TYPE', 'type');
					$tpl->Parse('MAIN', 'main');
					$content = $tpl->Fetch('MAIN');					
					break;
			}
			// Send content	
			$mail_list = $gData->GetNewsEmailList($hash['id'], false);
			send_news_mails($mail_list, 
							get_now(), 
							$hash['name'], 
							'', 
							$content, 
							$attach, 
							$attach,
							$hash['ishtml']
							);
		}
		
	}	
	
	// Echo page compilate time
	$gEndPoint = run_time($gStartPoint);
	echo_page_time($gEndPoint);	
}


/**
 * Function send_news_mails
 **/
function send_news_mails($mList, $mDateTime, $mNewsName, $mContentName, $mContent, $mAttach, $mAttachName,$mIsHTML)
{
	global $gData, $gOptions, $gStartPoint;
	
	// Init vars
	$rows = $gData->GetNumRows($mList);
	if ( $rows == 0 ) return false;
	
	// Make mail
	if ( $mIsHTML == 1 )
	{					
		$tplm = new FastTemplate(SHOP_CWD.'/'.TEMPLATES.'/_news/mails');
		$tplm->DefineTemplate(array('mail'		=>	'mail_html.htm'
									));
		$tplm->Assign(array('CATEGORY'  =>  htmlspecialchars($mNewsName),
							'NEWSNAME'  =>  htmlspecialchars($mContentName),
					    	'DATETIME' 	=>  date($gOptions['main_fmt_date_time'], strtotime($mDateTime)),
					    	'CONTENT'	=>  $mContent,
							'SHOPNAMES'	=>  $gOptions['attr_shop_name'],
		    				'SHOPNAME'	=>  htmlspecialchars($gOptions['attr_shop_name']),
		    				'SHOPURL'	=>  htmlspecialchars($gOptions['attr_shop_url']),
		    				'BASEURL'	=>  rtrim($gOptions['attr_base_url'], '/'),
				    		'SHOPEMAIL'	=>  htmlspecialchars($gOptions['attr_shop_email']),
				    		'SHOPORG'	=>  htmlspecialchars($gOptions['attr_shop_org']),
				    		'SHOPPHONE'	=>  htmlspecialchars($gOptions['attr_shop_phone']),
				    		'SHOPICQ'	=>  htmlspecialchars($gOptions['attr_shop_icq'])
					   		));
	}
	else 
	{
		$tplm = new FastTemplate(SHOP_CWD.'/'.TEMPLATES.'/_news/mails');
		$tplm->DefineTemplate(array('mail'		=>	'mail_text.htm'
									));		
		$tplm->Assign(array('CATEGORY'  =>  $mNewsName,
							'NEWSNAME'  =>  $mContentName,
					    	'DATETIME' 	=>  date($gOptions['main_fmt_date_time'], strtotime($mDateTime)),
					    	'CONTENT'	=>  $mContent,
		    				'SHOPNAME'	=>  $gOptions['attr_shop_name'],
		    				'SHOPURL'	=>  $gOptions['attr_shop_url'],
		    				'BASEURL'	=>  rtrim($gOptions['attr_base_url'], '/'),
				    		'SHOPEMAIL'	=>  $gOptions['attr_shop_email'],
				    		'SHOPORG'	=>  $gOptions['attr_shop_org'],
				    		'SHOPPHONE'	=>  $gOptions['attr_shop_phone'],
				    		'SHOPICQ'	=>  $gOptions['attr_shop_icq']
					   		));
	}
	$tplm->Parse('MAIL', 'mail');
	$mail_maket = $tplm->Fetch('MAIL');
	
	// Send mail
	$mailer = new Emailer(MAIL_SERVER);
	( $mIsHTML == 1) ? $mailer->SetTypeHTML() : $mailer->SetTypeText();
	$charset = '';
	$to_mails = '';
	if ( strlen($mAttach) > 0 )	$mailer->AddAttachment($mAttach, $mAttachName);
	for ( $i = 1; $i <= $rows; $i++ )
	{
		$hash = $gData->FetchRow($mList);
			
		if ( $charset != $hash[1] )
		{
			if ( $charset != '' ) 
			{
				$mailer->Send(rtrim($to_mails, ','), $gOptions['attr_shop_email'], ltrim($subject, " "));
				$to_mails = '';
			}		
			$charset = $hash[1];	
			$mailer->SetCharset($charset);
			$all_message = iconv(SHOP_CHARSET, 
								$charset, 
								str_replace('{CHARSET}', $charset, $mail_maket)
								);
			$subject = substr($all_message, strpos($all_message, 'Message_subject:')+16, strpos($all_message, 'Message_content:')-16);
			$message = substr($all_message, strpos($all_message, 'Message_content:')+16);		
			$mailer->AddMessage($message);
			$mailer->BuildMessage();
		}
		$to_mails .= $hash[0].',';
	}
	$mailer->Send(rtrim($to_mails, ','), $gOptions['attr_shop_email'], ltrim($subject, " "));
	
	return true;
}

?>