<?php

/**
 * reminder.php
 * ------------
 * @version 5.4.0
 * @copyright 2002-2010 Melbis Company
 * @link http://www.melbis.com
 * @author Dmitriy Kasyanov
 **/
 
// Require classes and includes
$script_path = ( strlen($_SERVER['PATH_TRANSLATED']) > 0 ) ? $_SERVER['PATH_TRANSLATED'] : $_SERVER['SCRIPT_FILENAME'];
if ( realpath(dirname($script_path).'/../privat/privat.php') === false || strlen($script_path) == 0 ) 
{
	$script_path = $_SERVER['argv'][0];
	if ( realpath(dirname($script_path).'/../privat/privat.php') === false ) die('Error: cannot define script path');
}
require_once(realpath(dirname($script_path).'/../privat/privat.php'));
require_once(SHOP_CWD.'/admin/includes/common.php');
require_once(SHOP_CWD.'/admin/class/show/class.FastTemplate.php');
require_once(SHOP_CWD.'/admin/class/util/class.Emailer.php');

// Set time limit 
@set_time_limit(3000); 

// Go
main();

/**
 * Function main
 **/
function main()
{
	global $gData, $gOptions, $gTpl, $gStartPoint;
	
	// Get start point for time
	$gStartPoint = run_time(0);
	
	// Connect to Data 
	$gData = data_connect(true);	

	
	// Send notice for remembers goods
	$goods = $gData->GetGoodsForRemember();
	$rows = $gData->GetNumRows($goods);
	for ( $i = 1; $i <= $rows; $i++ )
	{
		$hash = $gData->FetchHash($goods);
		// define what the goods
		if ( $hash['param_exists'] == 1 )
		{
			$how = $hash['store_add_how'];
			$status = $hash['store_add_status'];
		} 
		else 
		{
			$how = $hash['store_how'];
			$status = $hash['store_status'];		
		}
		// Test goods to order
		if ( $how == 0 || $status == 1 ) continue;
		//Send email
		$tplm = new FastTemplate(SHOP_CWD.'/'.TEMPLATES.'/_buy');
		$tplm->DefineTemplate(array('mail_message'	=>	'mail_message.htm'));
		$tplm->Assign(array('NAMES'  	=>  $hash['name'],
							'NAME'  	=>  htmlspecialchars($hash['name']),
					    	'URL'   	=>  rtrim($gOptions['attr_base_url'], '/').'/goods.php?id='.$hash['store_id'],
							'CHARSET' 	=>	SHOP_CHARSET,
							'SHOPNAMES'	=>  $gOptions['attr_shop_name'],
					    	'SHOPNAME'	=>  htmlspecialchars($gOptions['attr_shop_name']),
					    	'SHOPURL'	=>  htmlspecialchars($gOptions['attr_shop_url']),
					    	'SHOPEMAIL'	=>  htmlspecialchars($gOptions['attr_shop_email']),
					    	'SHOPORG'	=>  htmlspecialchars($gOptions['attr_shop_org']),
					    	'SHOPPHONE'	=>  htmlspecialchars($gOptions['attr_shop_phone']),
					    	'SHOPICQ'	=>  htmlspecialchars($gOptions['attr_shop_icq'])
					   ));
		$tplm->Parse('MAIL', 'mail_message');
		$mailer = new Emailer(MAIL_SERVER);
		$mailer->SetCharset(SHOP_CHARSET);
		$mailer->SetTypeHTML();
		$all_message = $tplm->Fetch('MAIL');
		$subject = substr($all_message, strpos($all_message, 'Message_subject:')+16, strpos($all_message, 'Message_content:')-16);
		$message = substr($all_message, strpos($all_message, 'Message_content:')+16);		
		$mailer->AddMessage($message);
  		$mailer->BuildMessage();
	  	$mailer->Send($hash['email'], $gOptions['attr_shop_email'], ltrim($subject, " "));	
	  	// Remove remembered
		$gData->ClearForRemember($hash['email'], $hash['store_id'], $hash['param_value_id']);		
	}	
		
	
	// Echo page compilate time
	$gEndPoint = run_time($gStartPoint);
	echo_page_time($gEndPoint);	
}

?>