<?php

/**
 * partner.php
 * -----------
 * @version 5.4.0
 * @copyright 2002-2010 Melbis Company
 * @link http://www.melbis.com
 * @author Dmitriy Kasyanov
 **/
 
// Define script folder 
define('FOLDER', './../');


// Require classes and includes
require_once('./privat/privat.php');
require_once('./includes/common.php');
require_once('./includes/admin.php');
require_once('./class/show/class.XML.php');
require_once('./class/util/class.PclZip.php');
require_once('./class/show/class.FastTemplate.php');


// Set time limit 
@set_time_limit(300); 

// Start session
session_start();

// Connect to Data
$gData = data_connect(true);

// What you need?
switch ($_POST['command'])
{
	case 'GET_HIT_GOODS' : 
		get_hit_goods(); 
		break;
	default : 
		echo "PHP_ERROR: Unknow command in line [".__LINE__."] :: Fail Command";
}

/**
 * Function get_hit_goods
 * Return hit goods data
 **/
function get_hit_goods()
{
	global $gData;
	
	$vars = explode('&', $_POST['values']);
	foreach ($vars as $var)
	{
		list($key, $value) = explode('=', $var);
		$input[$key] = urldecode($value);
	}
	
	// Start XML file
	$xml_file = './tmp/'.md5(session_id()).'.xml';
	$xml = new XML(SHOP_CHARSET, $xml_file);
	$xml->StartTag('MELBISSHOP', array('Version' => 'Melbis Shop v'.SCRIPT_VERSION));
		
	// Request
	$buy_goods = ( $input['type'] == 0 );
	$from_date = ( $input['from_date'] == 'True' );
	$date = $input['date'];
	$how = $input['how'];
	
	$goods = $gData->GetGoodsHitStat($buy_goods, $from_date, $date, $input['how']);
	$rows = $gData->GetNumRows($goods);
	$xml->StartTag('GOODS');
	for ( $i = 1; $i <= $rows; $i++ ) 
	{		
		$hash = $gData->FetchRow($goods);
		$xml->PutTag('HIT', array('id' => $hash[0]));	
	}
	$xml->CloseTag('GOODS');
	$xml->CloseTag('MELBISSHOP');
	$xml->Free();
	
	// Put result to archive
	xml_to_zip_answer($xml_file);
}

?>