<?php

/**
 * news_blocks.php
 * ---------------
 * @version 5.4.0
 * @copyright 2002-2010 Melbis Company
 * @link http://www.melbis.com
 * @author Dmitriy Kasyanov
 **/
 

/**
 * Function news_blocks
 * Return array news blocks
 **/
function news_blocks()
{
	global $gData, $gOptions;
	
	// Init vars
	$parse = array();
	$places = explode(';', $gOptions['index_how_news']);
	foreach ( $places as $key ) $parse[$key] = '';

	// Get news	
	$news = $gData->GetFirstPageNews();
	$rows = $gData->GetNumRows($news);	
	for ( $i = 1; $i <= $rows; $i++ )
	{
		$hash = $gData->FetchRow($news);
		// Init templates
		$tpl = new FastTemplate('./'.TEMPLATES.'/_index/news');
		$tpl->DefineTemplate(array('main' 			=> 'main.htm',  	 
				 				   'unit'			=> 'unit.htm',
								   'between_row'	=> 'between_row.htm',
								   'more'			=> 'more.htm',
								   'subscribe'		=> 'subscribe.htm',
								   'rss'			=> 'rss.htm'
								   ));
		// Get news list
		$news_list = $gData->GetNewsList($hash[0], $hash[8]);
		$news_list_rows = $gData->GetNumRows($news_list);								   
		if ( $news_list_rows == 0 ) continue;
		// start parse news list block		   
		for ( $n = 1; $n <= $news_list_rows; $n++ )
		{
			$hash_cont = $gData->FetchRow($news_list);
			if ( $n == $news_list_rows ) 
			{ 
				$tpl->Assign('BETWEENROW', ''); 
			}		
			$tpl->Assign(array('NAME'	=> htmlspecialchars($hash_cont[1]),
							   'ID'		=> $hash_cont[0],
							   'DATE'	=> date($gOptions['main_fmt_date'], strtotime($hash_cont[2])),
							   'TIME'	=> date($gOptions['main_fmt_time'], strtotime($hash_cont[2])),
							   'DESCR'	=> $hash_cont[3]
							   ));
			if ( strlen($hash_cont[4]) > 0 || strlen($hash_cont[5]) > 0 )
			{
				$tpl->Parse('MORE', 'more');
			}
			else 
			{
				$tpl->Assign('MORE', '');
			}
			// Parse unit
			$tpl->Parse('UNIT', '.unit');
		}	
		$tpl->Parse('BETWEENROW', 'between_row');
		$tpl->Assign(array('NAME'		=> htmlspecialchars($hash[1]),
						   'SPECIAL'	=> '',
						   'ID'			=> $hash[0]
						   ));
		if ( $hash[9] == 1 ) $tpl->Parse('SPECIAL', 'subscribe');
		if ( $hash[10] == 1 ) $tpl->Parse('SPECIAL', '.rss');
		$tpl->Parse('MAIN', 'main');
		$parse[$hash[7]] .= $tpl->Fetch('MAIN');		
	}
	
	return $parse;
}

?>