<?php

/**
 * vote_blocks.php
 * ---------------
 * @version 5.4.0
 * @copyright 2002-2010 Melbis Company
 * @link http://www.melbis.com
 * @author Dmitriy Kasyanov
 **/
 

/**
 * Function vote_blocks
 * Return array voting blocks
 **/
function vote_blocks()
{
	global $gData, $gOptions;
	
	// Init vars
	$parse = array();
	$places = explode(';', $gOptions['index_how_voting']);
	foreach ( $places as $key ) $parse[$key] = '';

	// Get news	
	$vote = $gData->GetFirstPageVote(get_date());
	$rows = $gData->GetNumRows($vote);	
	for ( $i = 1; $i <= $rows; $i++ )
	{
		$hash = $gData->FetchRow($vote);
		// Init templates
		$tpl = new FastTemplate('./'.TEMPLATES.'/_index/vote');
		$tpl->DefineTemplate(array('main' 			=> 'main.htm',  	 
				 				   'unit_radio'		=> 'unit_radio.htm',
				 				   'unit_check'		=> 'unit_check.htm',
								   'between_row'	=> 'between_row.htm',
								   'between_group'	=> 'between_group.htm',
								   'more'			=> 'more.htm',
								   'descr'			=> 'descr.htm'
								   ));
		// Get vote
		$vote_list = $gData->GetVoteList($hash[0]);
		$vote_list_rows = $gData->GetNumRows($vote_list);								   
		if ( $vote_list_rows == 0 ) continue;
		// start parse news list block		   
		$group_id = 0;
		$code = '';
		$group_code = '';
		for ( $n = 1; $n <= $vote_list_rows; $n++ )
		{
			$hash_list = $gData->FetchRow($vote_list);
			if ( $n == $vote_list_rows ) $tpl->Assign('BETWEENROW', ''); 
			if ( $group_id != $hash_list[5] && $n > 1 ) $tpl->Parse('UNIT', '.between_group');
			$tpl->Assign(array('NAME'	=> htmlspecialchars($hash_list[2]),
							   'ID'		=> $hash_list[1],
							   'GRPID'	=> $hash_list[5],
							   'NOTE'	=> $hash_list[3],
							   'STATE'	=> ''
							   ));
			if ( $group_id != $hash_list[5] ) 
			{
				$tpl->Assign('STATE', 'Checked');
				if ( $hash_list[4] != 1 ) $group_code .= $hash_list[5].'I';
			}
			$group_id = $hash_list[5];
			if ( strlen($hash_list[3]) > 0 )
			{
				$tpl->Parse('MORE', 'more');
			}
			else 
			{
				$tpl->Assign('MORE', '');
			}
			// Parse unit
			if ( $hash_list[4] != 1 )
			{
				$tpl->Parse('UNIT', '.unit_radio');
			}
			else 
			{
				$tpl->Parse('UNIT', '.unit_check');
				$code .= $hash_list[1].'I';
			}
		}	
		$tpl->Parse('BETWEENROW', 'between_row');
		$s = strtotime($hash[9]) - strtotime(get_date());
		$days = intval($s/86400)+1; 
		$tpl->Assign(array('NAME'		=> htmlspecialchars($hash[1]),
						   'DESCR'		=> '',
						   'CODE'		=> rtrim($code, 'I'),
						   'GROUPCODE'	=> rtrim($group_code, 'I'),
						   'STARTDATE'	=> date($gOptions['main_fmt_date'], strtotime($hash[8])),
						   'DAYS'		=> $days,
						   'ID'			=> $hash[0]
						   ));
		if ( strlen($hash[6]) > 0 ) 
		{
			$tpl->Assign('CONTENT', $hash[6]);
			$tpl->Parse('DESCR', 'descr');
		}	
		$tpl->Parse('MAIN', 'main');
		$parse[$hash[7]] .= $tpl->Fetch('MAIN');		
	}
	
	return $parse;
}

?>