<?php

/**
 * orders.php
 * ----------
 * @version 5.4.0
 * @copyright 2002-2010 Melbis Company
 * @link http://www.melbis.com
 * @author Dmitriy Kasyanov
 **/

// Define script folder 
define('FOLDER', './../');
 
// Require classes and includes
require_once('./privat/privat.php');
require_once('./includes/common.php');
require_once('./includes/admin.php');
require_once('./includes/basket.php');
require_once('./includes/orders.php');
require_once('./class/show/class.XML.php');
require_once('./class/util/class.PclZip.php');
require_once('./class/util/class.Emailer.php');
require_once('./class/show/class.FastTemplate.php');

// Set time limit 
@set_time_limit(300); 

// Start session
session_start();

// Connect to Data
$gData = data_connect(true);

// What you need?
switch ($_POST['command'])
{
	case 'SAVE_ORDER_NOTE' : 
		save_order_note(); 
		break;
	case 'UPDATE_ORDERS_ARCHIVE' : 
		update_orders_archive(); 
		break;
	case 'COMPARE_ARCHIVE_ORDERS' : 
		compare_archive_orders(); 
		break;
	case 'APPLY_ORDERS_UPDATE' : 
		apply_orders_update(); 
		break;
	case 'GET_CLIENT_FIELDS' : 
		get_client_fields(); 
		break;
	default : 
		echo "PHP_ERROR: Unknow command in line [".__LINE__."] :: Fail Command";
}


/**
 * Function apply_orders_update
 * Update orders from admin or manager
 **/
function apply_orders_update()
{
	global $gData, $gOptions;
	
	// Start XML file
	$xml_file = './tmp/'.md5(session_id()).'.xml';
	$xml = new XML(SHOP_CHARSET, $xml_file);
	$xml->StartTag('MELBISSHOP');	
	
	$order_put_result = array();
	
	$orders_tree = xml_get_tree(zip_file_to_string($_FILES['string_file']['tmp_name']));	
	$order_how = count($orders_tree['children']);
	for ( $i = 0; $i <= $order_how-1; $i++ )
	{
		$order = $orders_tree['children'][$i]['attributes']; 
		
		$goods = array();
		$goods_how = count($orders_tree['children'][$i]['children'][0]['children']);
		for ( $n = 0; $n <= $goods_how-1; $n++ )
		{
			$goods[] = $orders_tree['children'][$i]['children'][0]['children'][$n]['attributes'];
		}		
		
		$fields = array();
		$field_how = count($orders_tree['children'][$i]['children'][1]['children']);
		for ( $n = 0; $n <= $field_how-1; $n++ )
		{
			$fields[] = $orders_tree['children'][$i]['children'][1]['children'][$n]['attributes'];
		}	
		
		if ( $order['order_id']	== 0 ) 
		{
			$result = order_archive_insert($order, $goods, $fields);
			if ( $result['result'] == 'AddOK' )
			{
				$order_xml = get_order_xml($result['order_id']);
			}
			else 
			{
				$order_xml = '';
			}
		}
		else 
		{
			$result = order_archive_update($order, $goods, $fields);
			if ( $result['result'] == 'EditOK' )
			{
				$order_xml = get_order_xml($result['order_id']);
			}
			else 
			{
				$order_xml = '';
			}
		}
		$xml->StartTag('ORDER', $result);
		$xml->PutXML($order_xml);
		$xml->CloseTag('ORDER');
	}
	
	$xml->CloseTag('MELBISSHOP');
	$xml->Free();
	
	// Put result to archive
	xml_to_zip_answer($xml_file);	
}



?>