<?php

/**
 * partner.php
 * -----------
 * @version 5.4.0
 * @copyright 2002-2010 Melbis Company
 * @link http://www.melbis.com
 * @author Dmitriy Kasyanov
 **/

// Define script folder 
define('FOLDER', './../');
 
// Require classes and includes
require_once('./privat/privat.php');
require_once('./includes/common.php');
require_once('./includes/admin.php');
require_once('./class/show/class.XML.php');
require_once('./class/util/class.PclZip.php');
require_once('./class/util/class.Emailer.php');
require_once('./class/show/class.FastTemplate.php');


// Set time limit 
@set_time_limit(300); 

// Start session
session_start();

// Connect to Data
$gData = data_connect(true);

// What you need?
switch ($_POST['command'])
{
	case 'GET_ALL_PARTNERS' : 
		get_partners(false); 
		break;
	case 'SEARCH_PARTNERS' : 
		get_partners(true); 
		break;
	case 'SAVE_PARTNER_PARAM' : 
		save_partner_param(); 
		break;
	case 'GET_ACCOUNT_LOG' : 
		get_account_log(); 
		break;
	case 'ADD_ACCOUNT_REC' : 
		add_account_rec(); 
		break;
	case 'GET_STAT_COMMON' : 
		get_stat_common(); 
		break;
	case 'GET_STAT_PARTNER_TOP' : 
		get_stat_partner_top(); 
		break;
	case 'GET_STAT_PARTNER' : 
		get_stat_partner(); 
		break;
	case 'GET_STAT_PARTNER_DAYS' : 
		get_stat_partner_days(); 
		break;
	case 'GET_STAT_PARTNER_MONTH' : 
		get_stat_partner_month(); 
		break;
	case 'SEND_PARTNER_EMAILS' : 
		send_partner_emails(); 
		break;
	default : 
		echo "PHP_ERROR: Unknow command in line [".__LINE__."] :: Fail Command";
}

/**
 * Function get_partners
 * Return partners and their fields
 **/
function get_partners($mSearch)
{
	global $gData;
	
	// Prepare if do search
	if ( $mSearch ) 
	{
		$vars = explode('&', zip_file_to_string($_FILES['string_file']['tmp_name']));
		foreach ($vars as $var)
		{
			list($key, $value) = explode('=', $var);
			$input[$key] = urldecode($value);
		}
	}
	
	// Start XML file
	$xml_file = './tmp/'.md5(session_id()).'.xml';
	$xml = new XML(SHOP_CHARSET, $xml_file);
	$xml->StartTag('MELBISSHOP', array('Version' => 'Melbis Shop v'.SCRIPT_VERSION));
		
	// Request partners
	$partners = $gData->GetAllPartners($input);
	$rows = $gData->GetNumRows($partners);
	$how = ( $rows > 1000 ) ? 1000 : $rows;
	$xml->StartTag('PARTNERS', array('total' => $rows, 'transfer' => $how));
	$rules = $gData->GetPartnerMain();
	$work_type = ( $rules['work_type'] == 1 );
	for ( $i = 1; $i <= $how; $i++ ) 
	{		
		$partner = $gData->FetchHash($partners);
		unset($partner['charset']);
		if ( $work_type ) $partner['work_regime'] = 2;
		$xml->PutTag('PARTNER', $partner);
	}
	$xml->CloseTag('PARTNERS');
	$xml->CloseTag('MELBISSHOP');
	$xml->Free();
	
	// Put result to archive
	xml_to_zip_answer($xml_file);
}

/**
 * Function save_partner_param
 * Save partner parameters 
 **/
function save_partner_param()
{
	global $gData;
	
	
	$partner_list = explode(';', trim(zip_file_to_string($_FILES['string_file']['tmp_name']), ';'));
	foreach ( $partner_list as $partner_code) 
	{	
		$param = explode('|', $partner_code);
		$last_date = explode('.', $param[6]);
		if ( $param[1] == 2 )
		{
			// Remove partner and his data
			$gData->RemovePartner($param[0]);
		}
		else 
		{ 
			// Update Partner fields
			$gData->UpdatePartnerField($param[0], 'mult_proc', str_replace(',','.',$param[2]));
			$gData->UpdatePartnerField($param[0], 'mult_click', str_replace(',','.',$param[3]));
			$gData->UpdatePartnerField($param[0], 'active', $param[4]);
			$gData->UpdatePartnerField($param[0], 'status', $param[5]);
			$gData->UpdatePartnerField($param[0], 'work_regime', $param[7]);
			$gData->UpdatePartnerField($param[0], 'last_date', $last_date[2].'-'.$last_date[1].'-'.$last_date[0]);
		}
	}
	
	echo "QUERY_EXECUTE";
}


/**
 * Function get_account_log
 * Return partner account log records
 **/
function get_account_log()
{
	global $gData;

	// Start XML file
	$xml_file = './tmp/'.md5(session_id()).'.xml';
	$xml = new XML(SHOP_CHARSET, $xml_file);
	$xml->StartTag('MELBISSHOP', array('Version' => 'Melbis Shop v'.SCRIPT_VERSION));
	
	// Request partners
	$log = $gData->GetPartnerAccountLog($_POST['values']*1);
	$rows = $gData->GetNumRows($log);
	$how = ( $rows > 1000 ) ? 1000 : $rows;
	$xml->StartTag('LOG', array('total' => $rows, 'transfer' => $how));
	for ( $i = 1; $i <= $how; $i++ ) 
	{	
		$xml->PutTag('ROW', $gData->FetchHash($log));
	}
	$xml->CloseTag('LOG');
	$xml->CloseTag('MELBISSHOP');
	$xml->Free();
	
	// Put result to archive
	xml_to_zip_answer($xml_file);
}

/**
 * Function add_account_rec
 * Add record to account log
 **/
function add_account_rec()
{
	global $gData, $gOptions;
	
	// Prepare data
	$vars = explode('&', zip_file_to_string($_FILES['string_file']['tmp_name']));
	foreach ($vars as $var)
	{
		list($key, $value) = explode('=', $var);
		$input[$key] = urldecode($value);
	}
	
	// Get Partner
	$partner = $gData->GetPartner($input['id']*1);
	if ( $partner['id'] == 0 )
	{
		echo "RETURN_VALUE: WRONG_PARTNER_ID";
		exit;
	}
	
	// Add operation to account
	if ( $input['operate'] != 0 ) $input['suma'] = -$input['suma'];
	$gData->AddPartnerAccount($partner['id'], get_now(), $input['operate']*1, str_replace(',', '.', $input['suma'])*1, addslashes($input['notice']));

	echo "QUERY_EXECUTE";
	
	// Send notify email for partner
	$tplm = new FastTemplate(SHOP_CWD.'/'.TEMPLATES);
	$tplm->DefineTemplate(array('mail_message'	=>	'_partner/account/mails/mail_operate'.$input['operate'].'.htm'));
	$tplm->Assign(array('NAME'  	=>  htmlspecialchars($partner['name']),
				    	'ID'		=> 	$partner['id'],
				    	'CURR'		=>	htmlspecialchars($gOptions['main_base_curr']),
				    	'SUMA'		=>  number_format(str_replace(',', '.', $input['suma'])*1, 2, "," ,"'"),
				    	'NOTICE'	=>  htmlspecialchars($input['notice']),
						'CHARSET' 	=>	$partner['charset'],
						'BASEURL'	=>  rtrim($gOptions['attr_base_url'], '/'),
						'SHOPNAMES'	=>  $gOptions['attr_shop_name'],
			    		'SHOPNAME'	=>  htmlspecialchars($gOptions['attr_shop_name']),
				    	'SHOPURL'	=>  htmlspecialchars($gOptions['attr_shop_url']),
				    	'SHOPEMAIL'	=>  htmlspecialchars($gOptions['attr_shop_email']),
				    	'SHOPORG'	=>  htmlspecialchars($gOptions['attr_shop_org']),
				    	'SHOPPHONE'	=>  htmlspecialchars($gOptions['attr_shop_phone']),
			    		'SHOPICQ'	=>  htmlspecialchars($gOptions['attr_shop_icq'])
			   		    ));
	$tplm->Parse('MAIL', 'mail_message');
	$mailer = new Emailer(MAIL_SERVER);
	$mailer->SetCharset($partner['charset']);
	$mailer->SetTypeHTML();
	$all_message = iconv(SHOP_CHARSET, $partner['charset'], $tplm->Fetch('MAIL'));
	$subject = substr($all_message, strpos($all_message, 'Message_subject:')+16, strpos($all_message, 'Message_content:')-16);
	$message = substr($all_message, strpos($all_message, 'Message_content:')+16);		
	$mailer->AddMessage($message);
	$mailer->BuildMessage();
	$mailer->Send($partner['email'], $gOptions['attr_shop_email'], ltrim($subject, " "));		
	
}


/**
 * Function get_stat_common
 * Return common statistic
 **/
function get_stat_common()
{
	global $gData;

	// Prepare data
	$vars = explode('&', zip_file_to_string($_FILES['string_file']['tmp_name']));
	foreach ($vars as $var)
	{
		list($key, $value) = explode('=', $var);
		$input[$key] = urldecode($value);
	}
	
	// Start XML file
	$xml_file = './tmp/'.md5(session_id()).'.xml';
	$xml = new XML(SHOP_CHARSET, $xml_file);
	$xml->StartTag('MELBISSHOP', array('Version' => 'Melbis Shop v'.SCRIPT_VERSION));
	
	// Get statistic
	$log = $gData->GetPartnerStatCommon($input['start_date'], $input['end_date']);
	$rows = $gData->GetNumRows($log);
	$xml->StartTag('LOG');
	for ( $i = 1; $i <= $rows; $i++ ) 
	{	
		$hash = $gData->FetchHash($log);
		$part_reg = $hash['part_reg'] += $part_reg;
		$account_oper0 = $hash['account_oper0'] += $account_oper0;
		$account_oper1 = $hash['account_oper1'] += $account_oper1;
		$account_oper2 = $hash['account_oper2'] += $account_oper2;
		$account_oper0_sum = $hash['account_oper0_sum'] += $account_oper0_sum;
		$account_oper1_sum = $hash['account_oper1_sum'] += $account_oper1_sum;
		$account_oper2_sum = $hash['account_oper2_sum'] += $account_oper2_sum;
		$orders_all = $hash['orders_all'] += $orders_all;
		$orders_part = $hash['orders_part'] += $orders_part;
		$orders_all_sum = $hash['orders_all_sum'] += $orders_all_sum;
		$orders_part_sum = $hash['orders_part_sum'] += $orders_part_sum;
		$hash['part_active'] = ( $hash['part_total'] > 0 ) ? round($hash['part_active']/$hash['part_total']*100) : 0;
		$xml->PutTag('ROW', $hash);
	}
	$xml->CloseTag('LOG');
	$xml->CloseTag('MELBISSHOP');
	$xml->Free();
	
	// Put result to archive
	xml_to_zip_answer($xml_file);
}


/**
 * Function get_stat_partner_top
 * Return top partner statistic
 **/
function get_stat_partner_top()
{
	global $gData;

	// Prepare data
	$vars = explode('&', zip_file_to_string($_FILES['string_file']['tmp_name']));
	foreach ($vars as $var)
	{
		list($key, $value) = explode('=', $var);
		$input[$key] = urldecode($value);
	}
	
	// Start XML file
	$xml_file = './tmp/'.md5(session_id()).'.xml';
	$xml = new XML(SHOP_CHARSET, $xml_file);
	$xml->StartTag('MELBISSHOP', array('Version' => 'Melbis Shop v'.SCRIPT_VERSION));
	
	// Get statistic
	$partners = $gData->GetPartnerStatPartTop($input['sort_type'], $input['how'], $input['to_date']);
	$rows = $gData->GetNumRows($partners);
	$xml->StartTag('PARTNERS');
	for ( $i = 1; $i <= $rows; $i++ ) 
	{	
		$hash = $gData->FetchHash($partners);
		$hash['top'] = $i;
		$xml->PutTag('PARTNER', $hash);
	}
	$xml->CloseTag('PARTNERS');
	$xml->CloseTag('MELBISSHOP');
	$xml->Free();
	
	// Put result to archive
	xml_to_zip_answer($xml_file);
}


/**
 * Function get_stat_partner
 * Return base partner statistic
 **/
function get_stat_partner()
{
	global $gData;

	// Prepare data
	$vars = explode('&', zip_file_to_string($_FILES['string_file']['tmp_name']));
	foreach ($vars as $var)
	{
		list($key, $value) = explode('=', $var);
		$input[$key] = urldecode($value);
	}
	
	// Start XML file
	$xml_file = './tmp/'.md5(session_id()).'.xml';
	$xml = new XML(SHOP_CHARSET, $xml_file);
	$xml->StartTag('MELBISSHOP', array('Version' => 'Melbis Shop v'.SCRIPT_VERSION));
	
	// Get statistic
	$log = $gData->GetPartnerStatAll($input['start_date'].' '.$input['start_time'], 
									 $input['end_date'].' '.$input['end_time'],
									 $input['part_filter'],
									 addslashes($input['part_ids']));
	$rows = $gData->GetNumRows($log);									 
	$how = ( $rows > 2000 ) ? 2000 : $rows;
	$xml->StartTag('LOG', array('total' => $rows, 'transfer' => $how));
	for ( $i = 1; $i <= $how; $i++ ) 
	{	
		$hash = $gData->FetchHash($log);
		$hash['ip'] = long2ip($hash['ip']);
		$xml->PutTag('ROW', $hash);
	}
	$xml->CloseTag('LOG');
	$xml->CloseTag('MELBISSHOP');
	$xml->Free();
	
	// Put result to archive
	xml_to_zip_answer($xml_file);
}

/**
 * Function get_stat_partner_days
 * Return base partner statistic for days
 **/
function get_stat_partner_days()
{
	global $gData;

	// Prepare data
	$vars = explode('&', zip_file_to_string($_FILES['string_file']['tmp_name']));
	foreach ($vars as $var)
	{
		list($key, $value) = explode('=', $var);
		$input[$key] = urldecode($value);
	}
	
	// Start XML file
	$xml_file = './tmp/'.md5(session_id()).'.xml';
	$xml = new XML(SHOP_CHARSET, $xml_file);
	$xml->StartTag('MELBISSHOP', array('Version' => 'Melbis Shop v'.SCRIPT_VERSION));
	
	// Get statistic
	$log = $gData->GetPartnerStatDays($input['start_date'], 
									  $input['end_date'],
									  $input['part_filter'],
									  addslashes($input['part_ids']));
	$rows = $gData->GetNumRows($log);									 
	$how = ( $rows > 2000 ) ? 2000 : $rows;
	$xml->StartTag('LOG', array('total' => $rows, 'transfer' => $how));
	for ( $i = 1; $i <= $how; $i++ ) 
	{	
		$hash = $gData->FetchHash($log);
		$xml->PutTag('ROW', $hash);
	}
	$xml->CloseTag('LOG');
	$xml->CloseTag('MELBISSHOP');
	$xml->Free();
	
	// Put result to archive
	xml_to_zip_answer($xml_file);
}


/**
 * Function get_stat_partner_month
 * Return base partner statistic for month
 **/
function get_stat_partner_month()
{
	global $gData;

	// Prepare data
	$vars = explode('&', zip_file_to_string($_FILES['string_file']['tmp_name']));
	foreach ($vars as $var)
	{
		list($key, $value) = explode('=', $var);
		$input[$key] = urldecode($value);
	}
	
	// Start XML file
	$xml_file = './tmp/'.md5(session_id()).'.xml';
	$xml = new XML(SHOP_CHARSET, $xml_file);
	$xml->StartTag('MELBISSHOP', array('Version' => 'Melbis Shop v'.SCRIPT_VERSION));
	
	// Get statistic
	$log = $gData->GetPartnerStatMonth($input['start_date'], 
									   $input['end_date'],
									   $input['part_filter'],
									   addslashes($input['part_ids']));
	$rows = $gData->GetNumRows($log);									 
	$how = ( $rows > 2000 ) ? 2000 : $rows;
	$xml->StartTag('LOG', array('total' => $rows, 'transfer' => $how));
	for ( $i = 1; $i <= $how; $i++ ) 
	{	
		$hash = $gData->FetchHash($log);
		$xml->PutTag('ROW', $hash);
	}
	$xml->CloseTag('LOG');
	$xml->CloseTag('MELBISSHOP');
	$xml->Free();
	
	// Put result to archive
	xml_to_zip_answer($xml_file);
}


/**
 * Function send_partner_emails
 * Send email to partner 
 **/
function send_partner_emails()
{
	global $gData, $gOptions;
	
	$vars = explode('&', zip_file_to_string($_FILES['string_file']['tmp_name']));
	foreach ($vars as $var)
	{
		list($key, $value) = explode('=', $var);
		$input[$key] = urldecode($value);
	}	
	
		
	// Make message
	$tplm = new FastTemplate(SHOP_CWD.'/'.TEMPLATES);
	$tplm->DefineTemplate(array('mail_message'	=>	'_partner/mail_mess_from_admin.htm'));
	$tplm->Assign(array('SUBJECT'	=>	$input['subject'],
				    	'CONTENT'	=>  $input['content'],
						'BASEURL'	=>  rtrim($gOptions['attr_base_url'], '/'),
						'SHOPNAMES'	=>  $gOptions['attr_shop_name'],
			    		'SHOPNAME'	=>  htmlspecialchars($gOptions['attr_shop_name']),
				    	'SHOPURL'	=>  htmlspecialchars($gOptions['attr_shop_url']),
				    	'SHOPEMAIL'	=>  htmlspecialchars($gOptions['attr_shop_email']),
				    	'SHOPORG'	=>  htmlspecialchars($gOptions['attr_shop_org']),
				    	'SHOPPHONE'	=>  htmlspecialchars($gOptions['attr_shop_phone']),
			    		'SHOPICQ'	=>  htmlspecialchars($gOptions['attr_shop_icq'])
			   		    ));
	$tplm->Parse('MAIL', 'mail_message');
	$mail_maket = $tplm->Fetch('MAIL');	

	// Request partners mail list
	$partner = $gData->GetPartnerMailList();
	$rows = $gData->GetNumRows($partner);
	if ( $rows > 0 ) 
	{
		// Send mail
		$mailer = new Emailer(MAIL_SERVER);
		$mailer->SetTypeHTML();
		$charset = '';
		$to_mails = '';
		for ( $i = 1; $i <= $rows; $i++ )
		{	
			$hash = $gData->FetchRow($partner);
			
			if ( $charset != $hash[1] )
			{
				if ( $charset != '' ) 
				{
					$mailer->Send(rtrim($to_mails, ','), $gOptions['attr_shop_email'], ltrim($subject, " "));
					$to_mails = '';
				}		
				$charset = $hash[1];	
				$mailer->SetCharset($charset);
				$all_message = iconv(SHOP_CHARSET, $charset, str_replace('{CHARSET}', $charset, $mail_maket));
				$subject = substr($all_message, strpos($all_message, 'Message_subject:')+16, strpos($all_message, 'Message_content:')-16);
				$message = substr($all_message, strpos($all_message, 'Message_content:')+16);		
				$mailer->AddMessage($message);
				$mailer->BuildMessage();
			}
			$to_mails .= $hash[0].',';
		}
		$mailer->Send(rtrim($to_mails, ','), $gOptions['attr_shop_email'], ltrim($subject, " "));
	}
	
	echo "QUERY_EXECUTE";
}

?>