<?php

/**
 * spider.php
 * ----------
 * @version 5.4.0
 * @copyright 2002-2010 Melbis Company
 * @link http://www.melbis.com
 * @author Dmitriy Kasyanov
 **/

// Set Agent info
define('ITS_SPIDER', true);

// Define script folder
define('FOLDER', './../');


// Require classes and includes
require_once('./privat/privat.php');
require_once('./includes/common.php');
require_once('./includes/admin.php');
require_once('./class/show/class.XML.php');
require_once('./class/util/class.PclZip.php');



// Set time limit
@set_time_limit(300);

// Start session
session_start();

// Connect to Data
$gData = data_connect(true);

// What you need?
switch ($_POST['command'])
{
	case 'UPDATE_PRICELIST' :
		update_price_list();
		break;
	default :
		echo "PHP_ERROR: Unknow command in line [".__LINE__."] :: Fail Command";
}

/**
 * Function update_price_list
 * Do update price list
 **/
function update_price_list()
{
	global $gData, $gOptions;

	// Get data
	$price_tree = xml_get_tree(zip_file_to_string($_FILES['string_file']['tmp_name']));

    // Update Currency
	$rows = count($price_tree['children'][0]['children']);
	if ( $rows > 0 )
	{
		for ( $i = 0; $i <= $rows - 1; $i++ )
		{
			$hash = $price_tree['children'][0]['children'][$i]['attributes'];

			$gData->UpdateCurrency(addslashes($hash['name']), $hash['mult']*1);
		}

		// Recalc prices
		$currency = $gData->GetCurrency();
		$rows = $gData->GetNumRows($currency);
		for ( $i = 1 ; $i <= $rows; $i++ )
		{
			$hash = $gData->FetchRow($currency);
			$mult = ( $hash[3] == 1 && $hash[2] != 0) ? 1/$hash[2] : $hash[2];
			$gData->MakePriceAndSum($hash[0], $mult);
		}

	}

	// Prepare currencies
	$curr = array();
	$currency = $gData->GetCurrency();
	$rows = $gData->GetNumRows($currency);
	for ( $i = 1 ; $i <= $rows; $i++ )
	{
		$hash = $gData->FetchRow($currency);
		$mult = ( $hash[3] == 1 && $hash[2] != 0) ? 1/$hash[2] : $hash[2];
		$curr[$hash[1]] = $mult;
		$curr_id[$hash[1]] = $hash[0];
	}

	$set_how = ( $price_tree['children'][1]['attributes']['how'] == 'True' );
	$set_active = ( $price_tree['children'][1]['attributes']['active'] == 'True' );
	$set_status = ( $price_tree['children'][1]['attributes']['status'] == 'True' );
	$set_part_proc = ( $price_tree['children'][1]['attributes']['part_proc'] == 'True' );
	$set_prov_price = ( $price_tree['children'][1]['attributes']['prov_price'] == 'True' );
	$set_price = ( $price_tree['children'][1]['attributes']['price'] == 'True' );
	$set_disc_price = ( $price_tree['children'][1]['attributes']['disc_price'] == 'True' );
	$set_in_xml = ( $price_tree['children'][1]['attributes']['in_xml'] == 'True' );

	$rows = count($price_tree['children'][1]['children']);
	for ( $i = 0; $i <= $rows-1; $i++ )
	{
		$hash = $price_tree['children'][1]['children'][$i]['attributes'];

		if ( strlen($hash['code']) == 0 ) continue;

		if ( $set_price )
		{
			if ( $curr[$hash['price_curr']]*1 > 0 )
			{
				$price = 1*$hash['price']*$curr[$hash['price_curr']];
				$price_base = 1*$hash['price'];
				$price_curr_id = 1*$curr_id[$hash['price_curr']];
			}
			else
			{
				$price = 1*$hash['price'];
				$price_base = $price;
				$price_curr_id = 0;
			}
		}
		else
		{
			$price = '';
		}

		if ( $set_disc_price )
		{
			if ( $curr[$hash['disc_price_curr']]*1 > 0 )
			{
				$disc_price = 1*$hash['disc_price']*$curr[$hash['disc_price_curr']];
				$disc_price_base = 1*$hash['disc_price'];
				$dprice_curr_id = 1*$curr_id[$hash['disc_price_curr']];
			}
			else
			{
				$disc_price = 1*$hash['disc_price'];
				$disc_price_base = $disc_price;
				$dprice_curr_id = 0;
			}
		}
		else
		{
			$disc_price = '';
		}

		if ( $set_prov_price )
		{
			if ( $curr[$hash['prov_price_curr']]*1 > 0 )
			{
				$prov_price = 1*$hash['prov_price']*$curr[$hash['prov_price_curr']];
				$prov_price_base = 1*$hash['prov_price'];
				$pprice_curr_id = 1*$curr_id[$hash['prov_price_curr']];
			}
			else
			{
				$prov_price = 1*$hash['prov_price'];
				$prov_price_base = $prov_price;
				$pprice_curr_id = 0;
			}
		}
		else
		{
			$prov_price = '';
		}


		$gData->UpdatePriceList(addslashes($hash['code']),
								( $set_how ) ? $hash['how'] : '',
								( $set_active ) ? $hash['active'] : '',
								( $set_status ) ? $hash['status'] : '',
								( $set_part_proc ) ? $hash['part_proc'] : '',
								$prov_price,
								$prov_price_base,
								$pprice_curr_id,
								$price,
								$price_base,
								$price_curr_id,
								$disc_price,
								$disc_price_base,
								$dprice_curr_id,
								( $set_in_xml ) ? $hash['in_xml'] : ''
								);
	}

	// Save update time
	$gData->SaveShopValue('main_update_time', get_now());

	echo "QUERY_EXECUTE";
}


?>