<?php

/**
 * web_orders.php
 * --------------
 * @version 5.4.0
 * @copyright 2002-2010 Melbis Company
 * @link http://www.melbis.com
 * @author Dmitriy Kasyanov
 **/

// Define script folder 
define('FOLDER', './../');

 
// Require classes and includes
require_once('./privat/privat.php');
require_once('./includes/common.php');
require_once('./includes/guide_line.php');
require_once('./includes/basket.php');
require_once('./includes/orders.php');
require_once('./class/show/class.FastTemplate.php');
require_once('./class/util/class.Emailer.php');

// Start sessions
session_name(DB_NICK."_MSSADMIN");
session_start();

// Manager or administrator
if ( $_SESSION['login'] != 'admin' && strlen($_SESSION['login']) > 0 ) 
{
	define('ITS_MANAGER', true);
	$gManager = $_SESSION['manager'];
}	

// Go!
( strlen($_SESSION['login']) > 0 ) ? main() : shop_die('not_login', $_SESSION['login'], __LINE__, $_SERVER['REQUEST_URI']);


/**
 * Function main
 **/
function main()
{
	global $gData, $gOptions;

	// Get start point for time
	$gStartPoint = run_time(0);
	
	// Connect to Data 
	$gData = data_connect();	

	// Set options
	if ( isset($_GET['from']) ) $_SESSION['from'] = $_GET['from'];
	if ( isset($_POST['select']) ) 
	{
		$_SESSION['order_search'] = $_POST['search'];
		$_SESSION['order_what'] = $_POST['what'];
		$_SESSION['from'] = 0;
	}
	if ( isset($_POST['reset']) || isset($_POST['type']) ) 
	{
		$_SESSION['order_search'] = '';
		$_SESSION['order_what'] = '';
		$_SESSION['from'] = 0;
	}
			
	// Define what to do
	$action = $_GET['action'];
	if ( isset($_POST['action']) ) 
	{
		$action = $_POST['action'];
	}
	switch ( $action )
	{
		case 'save' :
			save_order();
			break; 
		case 'save_note' :
			save_note();
			break; 
		default :
			list_orders();
	} // switch	


}



/**
 * Function list_orders
 * Home page show all orders list
 **/
function list_orders()
{
	global $gData, $gOptions;
	
	// Init templates
	$tpl = new FastTemplate('./templates/'.$_SESSION['templ']);
	$tpl->DefineTemplate(array('blank' 			=> 'blank.htm',
							   'main'			=> '_orders/main.htm',
							   'begin'			=> '_orders/begin.htm',
							   'unit'			=> '_orders/unit.htm',
							   'empty'			=> '_orders/empty.htm',
							   'order_status0'	=> '_orders/order_status0.htm',
							   'order_status1'	=> '_orders/order_status1.htm',
							   'order_status2'	=> '_orders/order_status2.htm',
							   'order_status3'	=> '_orders/order_status3.htm',
							   'order_status4'	=> '_orders/order_status4.htm',
							   'order_payment1'	=> '_orders/order_payment1.htm',
							   'order_payment2'	=> '_orders/order_payment2.htm',
							   'do_pay'			=> '_orders/do_pay.htm',
							   'do_view'		=> '_orders/do_view.htm',
							   'add_options'	=> '_orders/add_options.htm'
							   ));
	
	$order = $gData->GetArchiveOrders($_SESSION['order_what'], addslashes($_SESSION['order_search']));	
	$rows = $gData->GetNumRows($order);
	$order_step = 20;
	if ( $rows > 0 ) 
	{ 
		$tpl->Parse('UNIT', 'begin');	
		$end = $order_step;
		$begin = $_SESSION['from']*1;
		if ( $rows < ($begin + $end) ) 
		{ 
			$end = $rows -$begin; 
		}
		$gData->DataSeek($order, $begin);		
		$order_num = '';
		for ( $n = 1; $n <= $end; $n++ ) 
		{			
			$hash = $gData->FetchHash($order);
			// calc left time
			$s = strtotime(get_now()) - strtotime($hash['date_time']);
			$d = intval($s/86400); 
			$s -= $d*86400;
			$h = intval($s/3600);
			$s -= $h*3600;
			$m = intval($s/60); 
			$s -= $m*60;
			// Calc vars
			$status = $hash['status']*1;
			$payment = $hash['get_payment']*1;
			if ( $payment == 0 ) $payment = 1;	
			$order_sum = $hash['total_sum'];

			// Assign
			$tpl->Assign(array('CODE'		=> htmlspecialchars($hash['code']),
							   'DATETIME'	=> date($gOptions['main_fmt_date_time'], strtotime($hash['date_time'])),
							   'ORDERSUM'	=> number_format($order_sum, $gOptions['main_prec'], "," ,"'"),
							   'DLEFT'		=> $d,
							   'HLEFT' 		=> $h,
							   'MLEFT' 		=> $m,
							   'ORDERID'	=> $hash['id'],
							   'ORDERSID'	=> $hash['sid'],
							   'STATUSID'	=> $status,
							   'PAYMENTID'	=> $payment,
							   'MANAGER'	=> ( strlen($hash['manager_name']) > 0 ) ? htmlspecialchars($hash['manager_name']) : '?',
							   'CURR'		=> htmlspecialchars($gOptions['main_base_curr'])
							   ));
			$tpl->Parse('STATUS', 'order_status'.$status);
			$tpl->Parse('PAYMENT', 'order_payment'.$payment);		
  			$tpl->Parse('DO', 'do_view');
  			$can_pay = ( $hash['online'] == 1 );
			if ( $hash['id'] > 0 ) $can_pay = ( $hash['get_payment'] == 1 && $hash['status'] < 2 );
			if ($can_pay ) $tpl->Parse('DO', '.do_pay');
			$tpl->Parse('UNIT', '.unit');	
		}
		// Parse guide line
		if ( $rows > $order_step ) 
		{
			$tpl->Assign('GUIDELINE', guide_line($_SESSION['from']*1, 
												 $order_step, 
												 $rows, 
												 './web_orders.php?a=1', 
												 '/admin/templates/'.$_SESSION['templ'].'/guide_line'));
		}
		else
		{
			$tpl->Assign('GUIDELINE', '');
		}	
	}		
	else
	{
		$tpl->Assign('GUIDELINE', '');
		$tpl->Parse('UNIT', 'empty');
	}
	
	// Echo filters vars
	$tpl->Assign(array('ORDER_CODE'		=> '',
	                   'GOODS_CODE' 	=> '',
	                   'GOODS_NAME' 	=> '',
	                   'CLIENT_LOGIN'	=> '',
	                   'STATUS0'		=> '',
	                   'STATUS1'		=> '',
	    	           'STATUS2' 		=> '',
	    	           'STATUS3' 		=> '',
	    	           'STATUS4' 		=> '',
	    	           'PAYMENT1' 		=> '',
	    	           'PAYMENT2' 		=> ''));
	$tpl->Assign(strtoupper($_SESSION['order_what']), 'Selected');
	$tpl->Assign('SEARCH', htmlspecialchars($_SESSION['order_search']));
	$tpl->Parse('ADDOPTIONS', 'add_options');	    	               
				
	$tpl->Parse('CONTENT', 'main');

	// Parse reserved names
	$tpl->Assign('CHARSET', SHOP_CHARSET);
					   	
	// Parse main page
	$tpl->Parse('BLANK', 'blank');
	$tpl->FastPrint('BLANK');
		
}



/**
 * Function save_order
 * Save order status or move to archive
 **/
function save_order()
{
	global $gData, $gOptions, $gManager;

	$order_id = $_POST['order_id']*1;
	$order_sid = addslashes($_POST['order_sid']);
	$order = $gData->GetArchiveOrder($order_id);	
	if ( $order['sid'] != $order_sid ) shop_die('no_found_order', $order_sid.$order_id, __LINE__, $_SERVER['REQUEST_URI']);
	
	// Update order status
	if ( ITS_MANAGER === true )
	{
		if ( $order['manager_id'] == $gManager['id'] || $order['manager_id'] == 0 )
		{
			$gData->SetOrderManager($order_id, $_SESSION['manager']['id'], get_now());
			setup_orders_archive(array($order_id => $_POST['status']), array($order_id => $_POST['payment']));
		}
	}
	else 
	{
		setup_orders_archive(array($order_id => $_POST['status']), array($order_id => $_POST['payment']));	
	}

	header("Location: ./web_orders.php?".session_name()."=".session_id());	

}



/**
 * Function save_note
 * Save order inside notice
 **/
function save_note()
{
	global $gData, $gManager;

	$order_id = $_POST['order_id']*1;
	$order_sid = addslashes($_POST['order_sid']);
	$order = $gData->GetArchiveOrder($order_id);	
	if ( $order['sid'] != $order_sid ) shop_die('no_found_order', $order_sid.$order_id, __LINE__, $_SERVER['REQUEST_URI']);
		
	if ( ITS_MANAGER === true )
	{
		if ( $order['manager_id'] == $gManager['id'] || $order['manager_id'] == 0 )
		{
			$gData->UpdateArchiveNotice($order_id, addslashes($_POST['inside_note']), get_now());
		}
	}
	else 
	{
		$gData->UpdateArchiveNotice($order_id, addslashes($_POST['inside_note']), get_now());
	}	
	
	
	header("Location: ./web_orders.php?".session_name()."=".session_id());	

}


?>
