<?php

/**
 * client.php
 * ----------
 * @version 5.4.0
 * @copyright 2002-2010 Melbis Company
 * @link http://www.melbis.com
 * @author Dmitriy Kasyanov
 **/
 
// Define script folder 
define('FOLDER', './');


// Require classes and includes
require_once('./admin/privat/privat.php');
require_once('./admin/includes/common.php');
require_once('./admin/includes/section.php');
require_once('./admin/includes/client.php');
require_once('./admin/includes/basket.php');
require_once('./admin/includes/anti_spam.php');
require_once('./admin/class/show/class.FastTemplate.php');
require_once('./admin/class/util/class.Emailer.php');


// Start sessions
shop_session();

// Go!
main();


/**
 * Function main
 **/
function main()
{
	global $gData, $gOptions, $gStartPoint, $gEndPoint;

	// Get start point for time
	$gStartPoint = run_time(0);
	
	// Connect to Data 
	$gData = data_connect();	
		
	// Make path for back
	make_back_path();
	
	// Define what to do
	$action = $_GET['action'];
	if ( isset($_POST['action']) ) 
	{
		$action = $_POST['action'];
	}
	switch ( $action )
	{
		case 'enter' : 
			$id = $gData->VerifyEnter(addslashes($_POST['login']), addslashes($_POST['pass']));
			if ( $id > 0 ) 
			{
			    client_activate($id);
			    
			    // Save auto enter
			    $cookie_name = @ereg_replace('[^[:alnum:]]', '_', SHOP_CWD.'_mshop_client');
			    if ( strlen($_POST['auto_enter']) > 0 )
			    {
			    	$cookie_days = 30;
			    	setcookie($cookie_name, $id.':'.md5($_POST['pass']), time() + 24*60*60*$cookie_days, '/', '.'.$_SERVER['HTTP_HOST']);
			    }
			    else 
			    {
			    	$cookie_days = 0;
			    	setcookie($cookie_name, '1', time() + 24*60*60*$cookie_days, '/', '.'.$_SERVER['HTTP_HOST']);
			    }
			    
				if ( $_SESSION['reg_and_back'] ) 
				{
			        header("Location: ./order.php?".session_name()."=".session_id());
			    }
				else
				{
					header("Location: ./client.php?action=home_page&".session_name()."=".session_id());
				}
			}
			else
			{
				enter_client(TRUE);
			}
			break;
		case 'register' :
			register_client();
			break;
		case 'try_register' :
			$error = try_register();
			if ( strlen($error) == 0 ) 
			{
			    add_client();
				if ( $_SESSION['reg_and_back'] ) 
				{
			        header("Location: ./order.php?".session_name()."=".session_id());
			    }
				else
				{
					header("Location: ./client.php?action=home_page&".session_name()."=".session_id());
				}				
			}
			else
			{
				register_client($error);
			}
			break;
		case 'forget' :
			forget($_POST['email']);
			break;		
		case 'home_page' :
			($_SESSION['client']['id'] > 1) ? home_page()
											: header("Location: ./client.php?".session_name()."=".session_id());
			break;					
		case 'reg_edit' :
			($_SESSION['client']['id'] > 1) ? reg_edit()
											: header("Location: ./client.php?".session_name()."=".session_id());
			break;	
		case 'try_change' :
			$error = try_change();
			if ( strlen($error) == 0 ) 
			{
			    save_changes();
				header("Location: ./client.php?action=home_page&".session_name()."=".session_id());
			}
			else
			{
				reg_edit($error);
			}
			break;	
		case 'orders' :
			($_SESSION['client']['id'] > 1) ? orders()
											: header("Location: ./client.php?".session_name()."=".session_id());
			break;	
		case 'logout' :
			// destroy session
			@session_destroy();
			setcookie(session_name(), "", time(), "/");
			// start new session
			shop_session();
			header("Location: ./client.php");
			break;								
		default :
			enter_client(FALSE);
	} // switch	

	// Echo page compilate time
	echo_page_time($gEndPoint);

}



/**
 * Function home_page
 * Home page client room
 **/
function home_page()
{
	global $gData, $gOptions, $gTpl, $gStartPoint, $gEndPoint, $gOptions;
	
	// Init templates
	$gTpl = new FastTemplate('./'.TEMPLATES);
	$gTpl->DefineTemplate(array('blank' 		=> 'blank.htm',
							    'main'			=> '_client/home/main.htm',
							    'cat_default'	=> '_client/home/cat_default.htm',
							    'client_unit'	=> '_client/home/reg_info/unit.htm',
							    'elem_file'		=> '_client/home/reg_info/elem_file.htm',
							    'elem_folder'	=> '_client/home/reg_info/elem_folder.htm',							    
							    'page_title'	=> '_client/home/page_title.htm'
							    ));
							    
	$ic_value = $_SESSION['payment']['multiplex']*1;
	if ( $ic_value > 0 ) 
	{
		$_SESSION['client']['orders_suma'] = round($_SESSION['client']['orders_suma']*$ic_value, 2);
		$_SESSION['client']['suma'] = round($_SESSION['client']['suma']*$ic_value, 2);
	}	
	// Get discount category name
	$category = $gData->GetCategoryName($_SESSION['client']['category_id']);
	if ( $category[0]*1 == 0 )
	{
		$gTpl->Parse('CATNAME', 'cat_default');
	}
	else 
	{
		$gTpl->Assign('CATNAME', htmlspecialchars($category[1]));
	}
	// Parse fields tree client
	$client_sth = $gData->GetClientData($_SESSION['client']['id']);
	$rows = $gData->GetNumRows($client_sth);
	$gTpl->Assign('CLUNIT', '');
	$allow = array();
	for ( $n = 1; $n <= $rows; $n++ ) 
	{			
		$hash = $gData->FetchRow($client_sth);
		if ( (strlen($hash[8]) > 0) || ($allow[$hash[0]] == 1) ) 
		{
			$allow[$hash[4]] = 1;
			$gTpl->Assign(array('NAME'	=> htmlspecialchars($hash[1]),
							    'LEVEL'	=> $hash[3]
								));
			// if folder
			if ( $hash[7] == 1) 
			{
				$gTpl->Parse('ELEMENT', 'elem_folder');
			}
			// if not folder
			else
			{
				$gTpl->Assign('VALUE', htmlspecialchars($hash[8]));
				$gTpl->Parse('ELEMENT', 'elem_file');
			}
			$gTpl->Parse('CLUNIT', ',client_unit');
		}
	}
	// Assign vars
	$gTpl->Assign(array('REGDATE'	=> date($gOptions['main_fmt_date'], strtotime($_SESSION['client']['reg_date'])),
					    'LASTDATE'	=> date($gOptions['main_fmt_date'], strtotime($_SESSION['client']['last_date'])),
					    'ORDERSUM'	=> number_format($_SESSION['client']['orders_suma'], $gOptions['main_prec'], "," ,"'"),
					    'PROC'		=> number_format($_SESSION['client']['proc'], 2, "," ,"'"),
					    'SUMA'		=> number_format($_SESSION['client']['suma'], $gOptions['main_prec'], "," ,"'"),
					    'PROCSEL'	=> ($_SESSION['client']['proc'] != 0) ? '1' : '0', 
						'SUMASEL'	=> ($_SESSION['client']['suma'] != 0) ? '1' : '0',
						'LOGIN'		=> htmlspecialchars($_SESSION['client']['login']),
						'EMAIL'		=> htmlspecialchars($_SESSION['client']['email']),
						'ECHARSET'	=> htmlspecialchars($_SESSION['client']['charset'])
					    ));

	$gTpl->Parse('CONTENT', 'main');

	// Echo shop variables
	echo_shop_variables('in_techpage', true);

	// Additional modules
	use_php_mod('client');
	
	$gTpl->Parse('PAGETITLE', 'page_title');
	 	
	// Parse main page
	$gTpl->Parse('BLANK', 'blank');
	$gEndPoint = run_time($gStartPoint);
	$gTpl->FastPrint('BLANK');
		
}


/**
 * Function reg_edit
 * Change values of registrations fields
 **/
function reg_edit($mError = '')
{
	global $gData, $gOptions, $gTpl, $gStartPoint, $gEndPoint, $gCharset;
	
	// Init templates
	$gTpl = new FastTemplate('./'.TEMPLATES);
	$gTpl->DefineTemplate(array('blank' 			=> 'blank.htm',
							    'main'				=> '_client/reg_edit/main.htm',
							    'unit'				=> '_client/reg_edit/unit.htm',
							    'elem_file'			=> '_client/reg_edit/elem_file.htm',
							    'elem_folder'		=> '_client/reg_edit/elem_folder.htm',
							    'flag'				=> '_client/reg_edit/flag.htm',
							    'input_text'		=> '_client/reg_edit/input_text.htm',
							    'input_select'		=> '_client/reg_edit/input_select.htm',
							    'input_option'		=> '_client/reg_edit/input_option.htm',
							    'err_email'			=> '_client/reg_edit/err_email.htm',
							    'err_pass_cmp'		=> '_client/reg_edit/err_pass_cmp.htm',
							    'err_field'			=> '_client/reg_edit/err_field.htm',
							    'page_title'		=> '_client/reg_edit/page_title.htm'
							    ));

	// Assign common vars
	$email = isset($_POST['email']) ? $_POST['email']
									: $_SESSION['client']['email'];
	$gTpl->Assign(array('ERROR' 	=> '',
					    'EMAIL'		=> htmlspecialchars($email),
					    'EMAILREQ'	=> ''
   			            ));	
	if ( $gOptions['main_email_req'] == 'True') 
	{
		$gTpl->Parse('EMAILREQ', '.flag');
	}
   			            
    // Assign charset	
	$charset = isset($_POST['charset']) ? $_POST['charset']
										: $_SESSION['client']['charset'];
    $charset_set = '';
    foreach ( $gCharset as $set )
    {
    	$sel = ( $set == $charset ) ? 'Selected'
    								: '';
    	$charset_set .= '<option value="'.$set.'" '.$sel.' >'.$set.'</option>';
    }
    $gTpl->Assign('CHARSETS', $charset_set);
    	
	// Analize error
	if ( strlen($mError) > 0 ) 
	{
	    $err = explode('&', $mError);
		if ( in_array('email_no', $err) ) $gTpl->Parse('ERROR', '.err_email');
		if ( in_array('pass_no', $err) ) $gTpl->Parse('ERROR', '.err_pass');
		if ( in_array('pass_cmp', $err) ) $gTpl->Parse('ERROR', '.err_pass_cmp');
	}
	else
	{
		$err = array();
	}

	
	// Get cleint fields data
	$client_sth = $gData->GetClientData($_SESSION['client']['id']);
	$rows = $gData->GetNumRows($client_sth);
	$client_data = array();
	for ( $n = 1; $n <= $rows; $n++ ) 
	{			
		$hash = $gData->FetchRow($client_sth);
		$client_data[$hash[0]] = $hash[8];
	}	
	
	// Get client fields
	$fields = $gData->GetClientFields();	

	// Parse fields tree
	$rows = $gData->GetNumRows($fields);
	if ( $rows > 0 ) 
	{ 
		for ( $n = 1; $n <= $rows; $n++ ) 
		{			
			$hash = $gData->FetchRow($fields);
			$gTpl->Assign(array('NAME'	=> htmlspecialchars($hash[1]),
								'LEVEL'	=> $hash[3],
								'ID'	=> $hash[0],
								'DESCR'	=> $hash[2]
								));
			// if folder
			if ( $hash[7] == 1) 
			{
				$gTpl->Parse('ELEMENT', 'elem_folder');
			}
			// if not folder
			else
			{
				// if need field
				if ( $hash[6] > 0 ) 
				{
					$gTpl->Parse('FLAG', 'flag');
					// Test for error
					if ( strlen($mError) > 0 && in_array('field_'.$hash[0], $err) ) 
					{
						$gTpl->Parse('ERROR', '.err_field');
					}						
				}
				else
				{
					$gTpl->Assign('FLAG', '');
				}
				// define default value
				$value = isset($_POST['field'.$hash[0]]) ? $_POST['field'.$hash[0]]
									       				 : $client_data[$hash[0]];	
				// it text field?
				if ( $hash[8]*1 == 0 ) 
				{
					$gTpl->Assign('VALUE', htmlspecialchars($value));
					$gTpl->Parse('INPUT', 'input_text');
				}
				else
				{
					$set = $gData->GetClientFieldSet($hash[0]);
					$set_rows = $gData->GetNumRows($set);
					$gTpl->Clear('OPTIONS');
					for ( $i = 1; $i <= $set_rows; $i++ ) 
					{			
						$s_hash = $gData->FetchRow($set);
						( $value == $s_hash[0] ) ? $sel = 'Selected'
							 					 : $sel = '';
						$gTpl->Assign(array('VALUE' 	=> $s_hash[0],
										    'SELECT'	=> $sel
										    ));
						$gTpl->Parse('OPTIONS', '.input_option');
					}
					$gTpl->Parse('INPUT', 'input_select');
				}
				$gTpl->Parse('ELEMENT', 'elem_file');
			}
			$gTpl->Parse('UNIT', '.unit');
		}
	}
	else 
	{
		$gTpl->Assign('UNIT', '');
	}
	$gTpl->Parse('CONTENT', 'main');

	// Echo shop variables
	echo_shop_variables('in_techpage', true);

	// Additional modules
	use_php_mod('client');
		
	$gTpl->Parse('PAGETITLE', 'page_title');
					   	
	// Parse main page
	$gTpl->Parse('BLANK', 'blank');
	$gEndPoint = run_time($gStartPoint);
	$gTpl->FastPrint('BLANK');
		
}


/**
 * Function forget
 * Reminder for client his password
 **/
function forget($mEmail)
{
	global $gData, $gOptions, $gTpl, $gStartPoint, $gEndPoint;
	
	// Init templates
	$gTpl = new FastTemplate('./'.TEMPLATES);
	$gTpl->DefineTemplate(array('blank' 		=> 'blank.htm',
							    'main'			=> '_client/enter/forget/main.htm',
							    'error'			=> '_client/enter/forget/error.htm',
							    'ok'			=> '_client/enter/forget/ok.htm',
							    'page_title'	=> '_client/enter/forget/page_title.htm'
							    ));
	
	// Get login and pass
	$exists = 0;
	if ( strlen($mEmail) > 0 ) list($exists, $login, $pass, $charset) = $gData->GetClientPass(addslashes($mEmail));
	if ( $exists > 0 ) 
	{
	    $gTpl->Parse('RESULT', 'ok');
		//Send mail
		$tplm = new FastTemplate('./'.TEMPLATES);
		$tplm->DefineTemplate(array('mail_message'	=>	'_client/enter/forget/mail_message.htm'));
		$tplm->Assign(array('LOGIN'  	=>  htmlspecialchars($login),
					    	'PASS'   	=>  htmlspecialchars($pass),
							'CHARSET' 	=>	$charset,
							'SHOPNAMES'	=>  $gOptions['attr_shop_name'],
					    	'SHOPNAME'	=>  htmlspecialchars($gOptions['attr_shop_name']),
					    	'SHOPURL'	=>  htmlspecialchars($gOptions['attr_shop_url']),
					    	'SHOPEMAIL'	=>  htmlspecialchars($gOptions['attr_shop_email']),
					    	'SHOPORG'	=>  htmlspecialchars($gOptions['attr_shop_org']),
					    	'SHOPPHONE'	=>  htmlspecialchars($gOptions['attr_shop_phone']),
					    	'SHOPICQ'	=>  htmlspecialchars($gOptions['attr_shop_icq'])
					   ));
		$tplm->Parse('MAIL', 'mail_message');
		$mailer = new Emailer(MAIL_SERVER);
		$mailer->SetCharset($charset);
		$mailer->SetTypeHTML();
		$all_message = iconv(SHOP_CHARSET, $charset, $tplm->Fetch('MAIL'));
		$subject = substr($all_message, strpos($all_message, 'Message_subject:')+16, strpos($all_message, 'Message_content:')-16);
		$message = substr($all_message, strpos($all_message, 'Message_content:')+16);		
		$mailer->AddMessage($message);
  		$mailer->BuildMessage();
	  	$mailer->Send($mEmail, $gOptions['attr_shop_email'], ltrim($subject, " "));					   
	}
	else
	{
		$gTpl->Parse('RESULT', 'error');
	}
	$gTpl->Parse('CONTENT', 'main');

	// Echo shop variables
	echo_shop_variables('in_techpage', true);

	// Additional modules
	use_php_mod('client');
		
	$gTpl->Parse('PAGETITLE', 'page_title');
					   	
	// Parse main page
	$gTpl->Parse('BLANK', 'blank');
	$gEndPoint = run_time($gStartPoint);
	$gTpl->FastPrint('BLANK');
		
}


/**
 * Function enter_client
 * Enter client through login and password
 **/
function enter_client($mWasError)
{
	global $gData, $gOptions, $gTpl, $gStartPoint, $gEndPoint;
	
	// Init templates
	$gTpl = new FastTemplate('./'.TEMPLATES);
	$gTpl->DefineTemplate(array('blank' 		=> 'blank.htm',
							    'main'			=> '_client/enter/main.htm',
							    'error'			=> '_client/enter/error.htm',
							    'order_note'	=> '_client/enter/order_note.htm',
							    'page_title'	=> '_client/enter/page_title.htm'
							    ));
	
	// Assign vars
	$gTpl->Assign('ERROR', '');
	( $_SESSION['reg_and_back'] ) ? $gTpl->Parse('ORDERNOTE', 'order_note')
								  : $gTpl->Assign('ORDERNOTE', '');
	if ( $mWasError ) $gTpl->Parse('ERROR', 'error');
	$gTpl->Parse('CONTENT', 'main');

	// Echo shop variables
	echo_shop_variables('in_techpage', true);

	// Additional modules
	use_php_mod('client');
		
	$gTpl->Parse('PAGETITLE', 'page_title');
					   	
	// Parse main page
	$gTpl->Parse('BLANK', 'blank');
	$gEndPoint = run_time($gStartPoint);
	$gTpl->FastPrint('BLANK');
		
}


/**
 * Function register_client
 * Register new client
 **/
function register_client($mError = '')
{
	global $gData, $gOptions, $gTpl, $gStartPoint, $gEndPoint, $gCharset;
	
	// Init templates
	$gTpl = new FastTemplate('./'.TEMPLATES);
	$gTpl->DefineTemplate(array('blank' 			=> 'blank.htm',
							    'main'				=> '_client/register/main.htm',
							    'unit'				=> '_client/register/unit.htm',
							    'elem_file'			=> '_client/register/elem_file.htm',
							    'elem_folder'		=> '_client/register/elem_folder.htm',
							    'flag'				=> '_client/register/flag.htm',
							    'input_text'		=> '_client/register/input_text.htm',
							    'input_select'		=> '_client/register/input_select.htm',
							    'input_option'		=> '_client/register/input_option.htm',
							    'err_login'			=> '_client/register/err_login.htm',
							    'err_login_exists'	=> '_client/register/err_login_exists.htm',
							    'err_email'			=> '_client/register/err_email.htm',
							    'err_pass'			=> '_client/register/err_pass.htm',
							    'err_pass_cmp'		=> '_client/register/err_pass_cmp.htm',
							    'err_field'			=> '_client/register/err_field.htm',
							    'verify_code'		=> '_client/register/verify_code.htm',
							    'page_title'		=> '_client/register/page_title.htm'
							    ));

	// Assign common vars
	$gTpl->Assign(array('ERROR' 	=> '',
					    'LOGIN'		=> htmlspecialchars($_POST['login']),
					    'EMAIL'		=> htmlspecialchars($_POST['email']),
					    'EMAILREQ'	=> '',
					    'AUTOREG'	=> ( isset($_POST['auto_reg']) || !isset($_POST['login'])) ? 'true' : 'false'
   			            ));	
	if ( $gOptions['main_email_req'] == 'True' ) 
	{
		$gTpl->Parse('EMAILREQ', '.flag');
	}
   			            
    // Assign charset	
    $charset = '';
    foreach ( $gCharset as $set )
    {
		( $_POST['charset'] == $set ) ? $sel = 'Selected'
							 		  : $sel = '';    	
    	$charset .= '<option value="'.$set.'" '.$sel.'>'.$set.'</option>';
    }
    $gTpl->Assign('CHARSETS', $charset);
    	
	// Anti spam verify code
	if ( $gOptions['main_no_spam_client'] == 'True' )
	{
		create_verify_code();
		$gTpl->Parse('VERIFYCODE', 'verify_code');
	}
	else 
	{
		$gTpl->Assign('VERIFYCODE', '');
	}     
    
	// Analize error
	if ( strlen($mError) > 0 ) 
	{
	    $err = explode('&', $mError);
		if ( in_array('login_no', $err) ) $gTpl->Parse('ERROR', '.err_login');
		if ( in_array('login_exists', $err) ) $gTpl->Parse('ERROR', '.err_login_exists');
		if ( in_array('email_no', $err) ) $gTpl->Parse('ERROR', '.err_email');
		if ( in_array('pass_no', $err) ) $gTpl->Parse('ERROR', '.err_pass');
		if ( in_array('pass_cmp', $err) ) $gTpl->Parse('ERROR', '.err_pass_cmp');
	}
	else
	{
		$err = array();
	}
							   
	// Get client fields
	$fields = $gData->GetClientFields();	

	// Parse fields tree
	$rows = $gData->GetNumRows($fields);
	if ( $rows > 0 ) 
	{ 
		for ( $n = 1; $n <= $rows; $n++ ) 
		{			
			$hash = $gData->FetchRow($fields);
			$gTpl->Assign(array('NAME'	=> htmlspecialchars($hash[1]),
								'DESCR'	=> $hash[2],
								'LEVEL'	=> $hash[3],
								'ID'	=> $hash[0]
								));
			// if folder
			if ( $hash[7] == 1) 
			{
				$gTpl->Parse('ELEMENT', 'elem_folder');
			}
			// if not folder
			else
			{
				// if need field
				if ( $hash[6] > 0 ) 
				{
					$gTpl->Parse('FLAG', 'flag');
					// Test for error
					if ( strlen($mError) > 0 && in_array('field_'.$hash[0], $err) ) 
					{
						$gTpl->Parse('ERROR', '.err_field');
					}						
				}
				else
				{
					$gTpl->Assign('FLAG', '');
				}
				// it text field?
				if ( $hash[8]*1 == 0 ) 
				{
					$gTpl->Assign('VALUE', htmlspecialchars($_POST['field'.$hash[0]]));
					$gTpl->Parse('INPUT', 'input_text');
				}
				else
				{
					$set = $gData->GetClientFieldSet($hash[0]);
					$set_rows = $gData->GetNumRows($set);
					$gTpl->Clear('OPTIONS');
					for ( $i = 1; $i <= $set_rows; $i++ ) 
					{			
						$s_hash = $gData->FetchRow($set);
						( $_POST['field'.$hash[0]] == $s_hash[0] ) ? $sel = 'Selected'
							 									   : $sel = '';
						$gTpl->Assign(array('VALUE' 	=> $s_hash[0],
										    'SELECT'	=> $sel
										    ));
						$gTpl->Parse('OPTIONS', '.input_option');
					}
					$gTpl->Parse('INPUT', 'input_select');
				}
				$gTpl->Parse('ELEMENT', 'elem_file');
			}
			$gTpl->Parse('UNIT', '.unit');
		}
	}
	else 
	{
		$gTpl->Assign('UNIT', '');
	}
	$gTpl->Parse('CONTENT', 'main');

	// Echo shop variables
	echo_shop_variables('in_techpage', true);

	// Additional modules
	use_php_mod('client');
		
	$gTpl->Parse('PAGETITLE', 'page_title');
					   	
	// Parse main page
	$gTpl->Parse('BLANK', 'blank');
	$gEndPoint = run_time($gStartPoint);
	$gTpl->FastPrint('BLANK');
		
}


/**
 * Function try_register
 * Verify information before register client
 **/
function try_register()
{
	global $gData, $gOptions;
	
	$error = '';
	if ( !isset($_POST['auto_reg'])  )
	{
		// Test for login
		if ( strlen($_POST['login']) == 0 ) $error .= 'login_no&';
		if ( $gData->ClientLoginExists(addslashes($_POST['login'])) > 0 ) $error .= 'login_exists&';
		// Test for password
		if ( strlen($_POST['pass']) == 0 ) $error .= 'pass_no&';
		if ( $_POST['pass'] != $_POST['pass2'] ) $error .= 'pass_cmp&';
	}		
	// Test for e-mail
	$need_test_email = ( strlen($_POST['email']) > 0 );
	if ( $gOptions['main_email_req'] == 'True' ) $need_test_email = true;
	if ( $need_test_email && !@eregi("^[_a-z0-9-]+(\.[_a-z0-9-]+)*@([0-9a-z](-?[0-9a-z])*\.)+[a-z]{2}([zmuvtg]|fo|me)?$", $_POST['email']) ) 
	{
	    $error .= 'email_no&';
	}
	
	// Get client fields
	$fields = $gData->GetClientFields();	
	// Test for need fields
	$rows = $gData->GetNumRows($fields);
	for ( $n = 1; $n <= $rows; $n++ ) 
	{			
		$hash = $gData->FetchRow($fields);
		// if need field
		if ( $hash[6] > 0 && $hash[7] != 1 ) 
		{
			if ( strlen($_POST['field'.$hash[0]]) == 0 ) $error .= 'field_'.$hash[0].'&';
		}
	}
	
	// Verify code
	$verify_code_pass = true;
	if ( $gOptions['main_no_spam_client'] == 'True' ) $verify_code_pass = right_verify_code();
	if ( ! $verify_code_pass ) $error .= 'spam_no&';

	
	return rtrim($error, '&');
}



/**
 * Function try_change
 * Verify information before change clients fields values
 **/
function try_change()
{
	global $gData, $gOptions;
	
	$error = '';
	// Test for password
	if ( $_POST['pass'] != $_POST['pass2'] ) $error .= 'pass_cmp&';
	// Test for e-mail
	$need_test_email = ( strlen($_POST['email']) > 0 );
	if ( $gOptions['main_email_req'] == 'True' ) $need_test_email = true;
	if ( $need_test_email && !@eregi("^[_a-z0-9-]+(\.[_a-z0-9-]+)*@([0-9a-z](-?[0-9a-z])*\.)+[a-z]{2}([zmuvtg]|fo|me)?$", $_POST['email']) ) 
	{
	    $error .= 'email_no&';
	}
	
	// Get client fields
	$fields = $gData->GetClientFields();	
	// Test for need fields
	$rows = $gData->GetNumRows($fields);
	for ( $n = 1; $n <= $rows; $n++ ) 
	{			
		$hash = $gData->FetchRow($fields);
		// if need field
		if ( $hash[6] > 0 && $hash[7] != 1 ) 
		{
			if ( strlen($_POST['field'.$hash[0]]) == 0 ) $error .= 'field_'.$hash[0].'&';
		}
	}
	
	return rtrim($error, '&');
}


/**
 * Function add_client
 * Add new client to database
 **/
function add_client()
{
	global $gData, $gOptions;
	
	
	// Insert client
	$login = addslashes($_POST['login']);
	$password = addslashes($_POST['pass']);
	if ( isset($_POST['auto_reg'])  )
	{
		srand((double)microtime()*1000000);
       	$time = explode( " ", microtime());
		$login = 'auto'.($gData->GetLastClientID()*1+1).substr((double)$time[0],2,3);
		$password = substr(md5(rand(0,9999999)),1 ,8);
	}
	$id = $gData->AddClient($login, $password, addslashes($_POST['email']), get_date(), addslashes($_POST['charset']));
	// If register many users with some login then remove last
	if ( $gData->ClientLoginExists(addslashes($_POST['login'])) > 1 ) 
	{
		$gData->RemoveClient($id);
		$error = try_register();
		register_client($error);	
		exit;
	}
	
	// Get client fields
	$fields = $gData->GetClientFields();	
	// Insert client fields
	$rows = $gData->GetNumRows($fields);
	for ( $n = 1; $n <= $rows; $n++ ) 
	{			
		$hash = $gData->FetchRow($fields);
		if ( strlen($_POST['field'.$hash[0]]) > 0 ) 
		{
			$gData->AddClientField($id, $hash[0], addslashes($_POST['field'.$hash[0]]));
		}
	}
	
	// Activate client
	client_activate($id);
			 	 		 
	//Send mail
	if ( strlen($_POST['email']) > 0 )
	{
		$tplm = new FastTemplate('./'.TEMPLATES);
		$tplm->DefineTemplate(array('mail_message'	=>	'_client/register/mail_register.htm'));
		$tplm->Assign(array('LOGIN'  	=>  htmlspecialchars($login),
					    	'PASS'   	=>  htmlspecialchars($password),
							'CHARSET' 	=>	$_POST['charset'],
							'SHOPNAMES'	=>  $gOptions['attr_shop_name'],
				    		'SHOPNAME'	=>  htmlspecialchars($gOptions['attr_shop_name']),
					    	'SHOPURL'	=>  htmlspecialchars($gOptions['attr_shop_url']),
					    	'SHOPEMAIL'	=>  htmlspecialchars($gOptions['attr_shop_email']),
					    	'SHOPORG'	=>  htmlspecialchars($gOptions['attr_shop_org']),
					    	'SHOPPHONE'	=>  htmlspecialchars($gOptions['attr_shop_phone']),
				    		'SHOPICQ'	=>  htmlspecialchars($gOptions['attr_shop_icq'])
				   		    ));
		$tplm->Parse('MAIL', 'mail_message');
		$mailer = new Emailer(MAIL_SERVER);
		$mailer->SetCharset($_POST['charset']);
		$mailer->SetTypeHTML();
		$all_message = iconv(SHOP_CHARSET, $_POST['charset'], $tplm->Fetch('MAIL'));
		$subject = substr($all_message, strpos($all_message, 'Message_subject:')+16, strpos($all_message, 'Message_content:')-16);
		$message = substr($all_message, strpos($all_message, 'Message_content:')+16);		
		$mailer->AddMessage($message);
		$mailer->BuildMessage();
  		$mailer->Send($_POST['email'], $gOptions['attr_shop_email'], ltrim($subject, " "));					   
	}
		
			 	 		 
	return TRUE;
}


/**
 * Function save_changes
 * Save client new fields values
 **/
function save_changes()
{
	global $gData;
	
	// Save new e-mail
	$_SESSION['client']['email'] = $_POST['email'];
	$gData->SaveClientBaseField($_SESSION['client']['id'], 'email', addslashes($_POST['email']));
	// Save new password if need
	if ( strlen($_POST['pass']) > 0 )
	{
		$gData->SaveClientBaseField($_SESSION['client']['id'], 'pass', addslashes($_POST['pass']));
	}
	// Save charset
	$_SESSION['client']['charset'] = $_POST['charset'];
	$gData->SaveClientBaseField($_SESSION['client']['id'], 'charset', addslashes($_POST['charset']));
	
	
	// Get client fields
	$fields = $gData->GetClientFields();	
	// Insert client fields
	$rows = $gData->GetNumRows($fields);
	for ( $n = 1; $n <= $rows; $n++ ) 
	{			
		$hash = $gData->FetchRow($fields);
		if ( strlen($_POST['field'.$hash[0]]) > 0 ) 
		{
			$gData->SaveClientFieldValue($_SESSION['client']['id'], $hash[0], addslashes($_POST['field'.$hash[0]]));
		}
		else 
		{
			$gData->RemoveClientFieldValue($_SESSION['client']['id'], $hash[0]);
		}
	}
		
	return TRUE;
}




/**
 * Function orders
 * Show current orders and from archive
 **/
function orders()
{
	global $gData, $gOptions, $gTpl, $gStartPoint, $gEndPoint, $gOptions;
	
	// Init templates
	$gTpl = new FastTemplate('./'.TEMPLATES);
	$gTpl->DefineTemplate(array('blank' 		=> 'blank.htm',
							    'main'			=> '_client/orders/main.htm',
							    'unit'			=> '_client/orders/unit.htm',
							    'orders'		=> '_client/orders/orders.htm',
							    'no_orders'		=> '_client/orders/no_orders.htm',
							    'order_status0'	=> '_client/orders/order_status0.htm',
							    'order_status1'	=> '_client/orders/order_status1.htm',
							    'order_status2'	=> '_client/orders/order_status2.htm',
							    'order_status3'	=> '_client/orders/order_status3.htm',
							    'order_status4'	=> '_client/orders/order_status4.htm',
							    'order_payment1'=> '_client/orders/order_payment1.htm',
							    'order_payment2'=> '_client/orders/order_payment2.htm',							    
							    'do_pay'		=> '_client/orders/do_pay.htm',
							    'do_view'		=> '_client/orders/do_view.htm',
							    'page_title'	=> '_client/orders/page_title.htm'
							    ));
	// Get orders list
	$orders = $gData->GetAllOrdersClient($_SESSION['client']['id']);							    
	$rows = $gData->GetNumRows($orders);
	if ( $rows > 0 )
	{
		for ( $n = 1; $n <= $rows; $n++ ) 
		{			
			$hash = $gData->FetchHash($orders);
			$gTpl->Assign(array('ORDERDATE' 	=> date($gOptions['main_fmt_date_time'], strtotime($hash['date_time'])),
							    'CODE'			=> htmlspecialchars($hash['code']),
							    'SUMA'			=> number_format($hash['total_sum'], $gOptions['orig_prec'], "," ,"'"),
							    'ORDERID'		=> $hash['id'],
							    'ORDERSID'		=> $hash['sid'],
							    'STATUSID'		=> $hash['status'],
							    'PAYMENTID'		=> $hash['get_payment']
							    ));	
			$gTpl->Parse('STATUS', 'order_status'.$hash['status']);
			$gTpl->Parse('PAYMENT', 'order_payment'.$hash['get_payment']);
			$gTpl->Parse('DO', 'do_view');
			$can_pay = ( $hash['online'] == 1 );
			if ( $hash['id'] > 0 ) $can_pay = ( $hash['get_payment'] == 1 && $hash['status'] < 2 );
			if ($can_pay ) $gTpl->Parse('DO', '.do_pay');
			$gTpl->Parse('UNIT', '.unit');
		}
		$gTpl->Assign('CURR', $gOptions['orig_base_curr']);
		$gTpl->Parse('ORDERS', 'orders');
	}
	else
	{
		$gTpl->Parse('ORDERS', 'no_orders');
	}
							    
	$gTpl->Parse('CONTENT', 'main');

	// Echo shop variables
	echo_shop_variables('in_techpage', true);

	// Additional modules
	use_php_mod('client');
		
	$gTpl->Parse('PAGETITLE', 'page_title');
	 	
	// Parse main page
	$gTpl->Parse('BLANK', 'blank');
	$gEndPoint = run_time($gStartPoint);
	$gTpl->FastPrint('BLANK');
		
}

?>