<?php

/**
 * compare.php
 * -----------
 * @version 5.4.0
 * @copyright 2002-2010 Melbis Company
 * @link http://www.melbis.com
 * @author Dmitriy Kasyanov
 **/

// Define script folder 
define('FOLDER', './');

 
// Require classes and includes
require_once('./admin/privat/privat.php');
require_once('./admin/includes/common.php');
require_once('./admin/includes/client.php');
require_once('./admin/includes/basket.php');
require_once('./admin/includes/goods.php');
require_once('./admin/class/show/class.FastTemplate.php');

// Start sessions
shop_session();

// Go!
main();


/**
 * Function main
 **/
function main()
{
	global $gData, $gOptions, $gTpl, $gStartPoint, $gEndPoint;

	// Get start point for time
	$gStartPoint = run_time(0);
	
	// Connect to Data 
	$gData = data_connect();	

	// Define client
	if ( !isset($_SESSION['client']) ) 
	{ 
		header("Location: ./");  
	 	exit;
	}
	
	// What to do
	if ( isset($_GET['id']) ) add_goods();
	if ( isset($_GET['remove_id']) ) remove_goods();
	if ( isset($_GET['go']) ) 
	{
		show_compare();
	}
	else 
	{
		show_list();
	}

	// Echo page compilate time
	echo_page_time($gEndPoint);	
}	

/**
 * Function add_goods
 * Add goods to compare list
 **/
function add_goods()
{
	$goods_list = explode(',', $_SESSION['compare']);
	$id = $_GET['id']*1;
	if ( $id == 0 ) exit;
	if ( !in_array($id, $goods_list) ) array_push($goods_list, $id);
	$_SESSION['compare'] = implode(',', $goods_list);
}

/**
 * Function remove_goods
 * Remove goods from compare list
 **/
function remove_goods()
{
	$goods_list = explode(',', $_SESSION['compare']);
	$remove_id = $_GET['remove_id']*1;
	$new_list = array();
	foreach ($goods_list as $id )
	{
		if ( $id*1 != $remove_id ) array_push($new_list, $id);
	}
	$_SESSION['compare'] = implode(',', $new_list);
}

/**
 * Function show_list
 * Return goods list for compare
 **/
function show_list()
{
	global $gData, $gOptions, $gTpl, $gStartPoint, $gEndPoint;

	
	// Init templates
	$gTpl = new FastTemplate('./'.TEMPLATES.'/_compare/list');
	$gTpl->DefineTemplate(array('main' 	=> 'main.htm',
								'unit'	=> 'unit.htm'
								));	
	
	// Parsing goods for compare
	$goods_sth = $gData->GetCompareGoods('0'.$_SESSION['compare']);
	$rows = $gData->GetNumRows($goods_sth);
	$num = 0;
	for ($i = 1; $i <= $rows; $i++)
	{
		$goods = $gData->FetchHash($goods_sth);
		if ( $goods[id]*1 == 0 ) continue;
		$gTpl->Assign(array('NAME'	=> htmlspecialchars($goods['name']),
						    'ID'	=> htmlspecialchars($goods['id'])
						    ));		
		$gTpl->Parse('UNIT', '.unit');
		$num++;
	}
	
	// Test for count
	if ( $num == 0 ) 
	{
		echo '<html><body><script> window.close(); </script></body></html>';
		exit;
	}	
				   
	// Echo shop variables
	echo_shop_variables('in_techpage');

	// Parse main page
	$gTpl->Parse('MAIN', 'main');
	$gEndPoint = run_time($gStartPoint);
	$gTpl->FastPrint('MAIN');	
}


/**
 * Function show_compare
 * Show goods for compare
 **/
function show_compare()
{
	global $gData, $gOptions, $gTpl, $gStartPoint, $gEndPoint;
	
	// Default vars
	$client_category = $_SESSION['client']['category_id']*1;
	$ic_value = $_SESSION['payment']['multiplex']*1;		
	
	// Init templates
	$gTpl = new FastTemplate('./'.TEMPLATES.'/_compare');
	$gTpl->DefineTemplate(array('main' 			=> 'main.htm',
				 				'price_client'	=> 'price_client.htm',
				 				'price_new'		=> 'price_new.htm',
				 				'price_simple'	=> 'price_simple.htm',
								'name'			=> 'name.htm',
								'icon'			=> 'icon.htm',
								'descr'			=> 'descr.htm',
				 				'unit'			=> 'unit.htm',
								'values'		=> 'values.htm',
								'status0'		=> 'status0.htm',
							   	'status1'		=> 'status1.htm',
							   	'status2'		=> 'status2.htm',
							   	'status3'		=> 'status3.htm',
							   	'apendix_name'	=> 'apendix_name.htm'
								));	
	
	// Parsing goods for compare
	$goods_sth = $gData->GetCompareGoods('0'.$_SESSION['compare']);
	$rows = $gData->GetNumRows($goods_sth);
	for ( $g = 1; $g <= $rows; $g++ ) 
	{			
		$hash = $gData->FetchHash($goods_sth);
			
		// Make icon
		if ( is_file('./files/store'.$hash['id'].'.jpg') ) 
		{
		    $img_file = 'files/store'.$hash['id'].'.jpg';
		} 
		else
		{
			$img_file = 'files/store_default.jpg';
		}	
			
		// Make Apendix link
		if ( is_file('./files/apendix'.$hash['id'].'.htm') ) 
		{
    		if ( $hash['apendix_type'] == 0) 
			{
        		$apendix_link = ' href="descr.php?id='.$hash['id'].'" ';
	        	$apendix_link .= ' onclick="ShowApendix('."$hash[id], $hash[xpos], $hash[ypos], $hash[w], $hash[h]".'); return false;" ';	        		
				$gTpl->Assign('APENDIXLINK', $apendix_link);
				$gTpl->Parse('APENDIXNAME', 'apendix_name');
			}
			else 
			{
				$gTpl->Assign('APENDIXLINK', "href=\"goods.php?id=$hash[id]\" target=_blank");
				$gTpl->Parse('APENDIXNAME', 'apendix_name');
			}
		}
		else 
		{
			$gTpl->Assign(array('APENDIXLINK' => '', 'APENDIXNAME' => ''));
		}

		// Make price offer
		list($new_price, $disc_proc, $disc_suma, $price_offer) = calc_goods_price($hash['id'], $hash['price'], $hash['disc_price']);			
		$price = $hash['price'];
		$left_sum = $price - $new_price;
		
		// Info currency
		if ( $ic_value > 0 ) 
		{
			$price = round($price*$ic_value, 2);
			$new_price = round($new_price*$ic_value, 2);
			$left_sum = round($left_sum*$ic_value, 2);
		}			
		
		// Assign vars		
		$gTpl->Assign(array('VALUE'	=> htmlspecialchars($hash['name']),
							'LINK'	=> 'goods.php?id='.$hash['id']
							));
		$gTpl->Parse('NAMES', '.name');
		$gTpl->Assign('VALUE', $hash['descr']);
		$gTpl->Parse('DESCRS', '.descr');
		$gTpl->Assign('ICON', $img_file);
		$gTpl->Parse('ICONS', '.icon');
		$gTpl->Assign(array('PRICE'		=> number_format($price, $gOptions['main_prec'], "," ,"'"),
					    	'NEWPRICE'	=> number_format($new_price, $gOptions['main_prec'], "," ,"'"),
					    	'LEFTSUM'	=> number_format($left_sum, $gOptions['main_prec'], "," ,"'"),
					    	));
		$gTpl->Parse('PRICES', '.'.$price_offer);
		$gTpl->Parse('STATUSES', '.status'.$hash['status']);
	}
		
	// Parse goods information	
	$comp_info = $gData->GetInfoCompareGoods('0'.$_SESSION['compare']);
	$comp_info_rows = $gData->GetNumRows($comp_info);
	$allow = array();
	$gTpl->Assign('UNIT', '');
	for ( $n = 1; $n <= $comp_info_rows; $n++ ) 
	{			
		$hash = $gData->FetchHash($comp_info);
		if ( ($hash['info_id']*1 > 0) || ($allow[$hash['id']] == 1) ) 
		{
			$allow[$hash[tindex]] = 1;
			$gTpl->Assign(array('NAME'	=> htmlspecialchars($hash['name']),
								'LEVEL'	=> $hash['tlevel']
								));
			$info_values = $gData->GetCompareInfoValues('0'.$_SESSION['compare'], $hash['id']);
			$gTpl->Clear('VALUES');
			for ( $g = 1; $g <= $rows; $g++ ) 
			{
				$hash_value = $gData->FetchRow($info_values);
				$value = htmlspecialchars($hash_value[0]);
				if ( strpos($hash_value[0], 'ftp://') !== false || strpos($hash_value[0], 'http://') !== false ) 
				{
					if ( strlen($value) > 15 ) $value = substr($value, 0, 15).'...';
					$value = '<a href="'.$hash_value[0].'" target=_blank>'.$value.'</a>';
				}				
				$gTpl->Assign('VALUE', $value);
				$gTpl->Parse('VALUES', '.values');
			}
			$gTpl->Parse('UNIT', ',unit');
		}
	}
				   
	// Echo shop variables
	echo_shop_variables('in_techpage');

	// Parse main page
	$gTpl->Parse('MAIN', 'main');
	$gEndPoint = run_time($gStartPoint);
	$gTpl->FastPrint('MAIN');	
}

?>