<?php

/**
 * param.php
 * ---------
 * @version 5.4.0
 * @copyright 2002-2010 Melbis Company
 * @link http://www.melbis.com
 * @author Dmitriy Kasyanov
 **/

// Define script folder 
define('FOLDER', './');
 
// Require classes and includes
require_once('./admin/privat/privat.php');
require_once('./admin/includes/common.php');
require_once('./admin/class/show/class.FastTemplate.php');

// Start sessions
shop_session();

// Go!
main();


/**
 * Function main
 **/
function main()
{
	global $gData, $gOptions, $gTpl, $gStartPoint;

	// Get start point for time
	$gStartPoint = run_time(0);
	
	// Connect to Data 
	$gData = data_connect();	

	
	// Do save currency?
	if ( strlen($_POST['currency']) > 0 ) 
	{
	    $id = $_POST['currency'];
		if ( $id > 0 ) 
		{
			$_SESSION['payment']['id'] = $id;
			$_SESSION['payment']['curr_name'] = $_POST['curr_name'.$id];
			$_SESSION['payment']['multiplex'] = $_POST['mult'.$id];
			$_SESSION['payment']['curr_prec'] = $_POST['curr_prec'.$id];
		}
		else
		{
			unset($_SESSION['payment']);
		}
		echo '<script>window.opener.document.location.reload();  window.close(); </script>';
		exit;
	}
	

	// Get payments
	$pay = $gData->GetPayment();	
	$rows = $gData->GetNumRows($pay);

	// Parse payments tree
	$gTpl = new FastTemplate('./'.TEMPLATES.'/_currency');
	$gTpl->DefineTemplate(array('main' 			=> 'main.htm',  	 
			 				    'unit' 			=> 'unit.htm',
							    'elem_file'		=> 'elem_file.htm',
							    'elem_folder'	=> 'elem_folder.htm',
							    'type_info'		=> 'type_info.htm',
							    'type_pay'		=> 'type_pay.htm'
							    ));
	$base_check = 'CHECKED';
	for ( $n = 1; $n <= $rows; $n++ ) 
	{			
		$hash = $gData->FetchRow($pay);
		$gTpl->Assign(array('ID'	=> $hash[0],
				    		'NAME'	=> htmlspecialchars($hash[1]),
				    		'DESCR'	=> $hash[2]
				    		));
		// if folder
		if ( $hash[6] == 1) 
		{
			$gTpl->Parse('ELEMENT', 'elem_folder');
		}
		// if not folder
		else
		{
			// if info type
			( $hash[13] == 0 ) ? $gTpl->Parse('TYPE', 'type_pay')
							   : $gTpl->Parse('TYPE', 'type_info');
			// calc multiplexor
			if ( $hash[9] == 1 && $hash[8] > 0) 
			{
			    $mult = 1;
				$mult_full = round(1/$hash[8], 12);
				$base = number_format($hash[8], 4, "," ,"'");
			}
			else
			{
				$mult = number_format($hash[8], 4, "," ,"'");
				$mult_full = $hash[8];
				$base = 1;
			}
			// checked?
			if ( $hash[0] == $_SESSION['payment']['id'] ) 
			{
			    $checked = 'CHECKED';
				$base_check = '';
			}
			else
			{
				$checked = '';
			}
			$gTpl->Assign(array('CURRNAME'	=> $hash[7],
							    'MULT'		=> $mult,
							    'MULTFULL'	=> $mult_full,
							    'PRECISION'	=> $hash[10],
							    'BASE'		=> $base,
							    'CHECK'		=> $checked
							    ));
			$gTpl->Parse('ELEMENT', 'elem_file');
		}
		// common vars
		$gTpl->Assign(array('NAME'		=> htmlspecialchars($hash[1]),
						    'LEVEL'		=> $hash[3]
						    ));
		$gTpl->Parse('UNIT', ',unit');
	}
	if ( $rows == 0) $gTpl->Assign('UNIT', '');
	
	// Parsing page properties
	$gTpl->Assign('BASECHECK', $base_check);
	$gTpl->Assign('BASECURR', $gOptions['orig_base_curr']);
	
	// Echo shop variables
	echo_shop_variables('in_techpage');	

	// Parse main page
	$gTpl->Parse('MAIN', 'main');
	$gEndPoint = run_time($gStartPoint);
	$gTpl->FastPrint('MAIN');
	
	// Echo page compilate time
	echo_page_time($gEndPoint);
		
}


?>