<?php

/**
 * descr.php
 * ---------
 * @version 5.4.0
 * @copyright 2002-2010 Melbis Company
 * @link http://www.melbis.com
 * @author Dmitriy Kasyanov
 **/

// Define script folder 
define('FOLDER', './');

 
// Require classes and includes
require_once('./admin/privat/privat.php');
require_once('./admin/includes/common.php');
require_once('./admin/includes/client.php');
require_once('./admin/includes/basket.php');
require_once('./admin/class/show/class.FastTemplate.php');

// Start sessions
shop_session();

// Go!
main();


/**
 * Function main
 **/
function main()
{
	global $gData, $gOptions, $gTpl, $gStartPoint;

	// Get start point for time
	$gStartPoint = run_time(0);
	
	// Connect to Data 
	$gData = data_connect();	

	// Get page properties
	if ( !isset($_GET['id']) && !isset($_GET['psu']) )  
	{ 
		header("Location: ./");  
	 	exit; 
	}
	$id = $_GET['id']*1;
	$psu_code = $_GET['psu'];
	if ( strlen($psu_code) > 0 )
	{
		$id = $gData->FindGoodsPSU(addslashes($psu_code));
		if ( $id == 0 ) 
		{
			header("Location: ./");  
	 		exit; 
		}		
	}	
	
	// Request Goods
	$goods = $gData->GetGoods($id);
	if ( ($goods['id']*1 == 0) || ($goods['active'] == 0))  
	{ 
		header("Location: ./");  
	 	exit; 
	}
	
	// Redirect to psevdo-static url
	if ( strlen($psu_code) == 0 && strlen($goods['seo_psu']) > 0 )
	{
		header("Location: ./descr_".urlencode($goods['seo_psu']).'.htm?'.session_name()."=".session_id());  
	 	exit; 
	}	
	
	// Content exists?
	if ( !file_exists('./files/apendix'.$id.'.htm') ) 
	{
		//echo '<script> window.close(); </script>';
		exit;
	}
	
	// Save shop statistic
	save_shop_stat('descr', $id);
						 	
	
	// Init templates
	$gTpl = new FastTemplate('./'.TEMPLATES.'/_descr');
	$gTpl->DefineTemplate(array('main' 		=> 'main.htm',
								'redirect'	=> 'redirect.htm'));
	
	// Parse nil info keynames
	$info_key = $gData->GetInfoAllKeyName('in_preview');
	$info_key_rows = $gData->GetNumRows($info_key);	
	for ( $n = 1; $n <= $info_key_rows; $n++ ) 
	{			
		$hash = $gData->FetchRow($info_key);
		$gTpl->Assign($hash[0], '');
	}		
	
	// Parse info tree
	if ( $gOptions['main_descr_info'] == 'True' )
	{
		$info = $gData->GetInfoGoods($id, 'in_preview');
		$info_rows = $gData->GetNumRows($info);
		if ( $info_rows > 0 ) 
		{ 
			$tpl_sub = new FastTemplate('./'.TEMPLATES.'/_descr/info');
			$tpl_sub->DefineTemplate(array('main' 			=> 'main.htm',  	 
					 				   	   'unit' 			=> 'unit.htm',
					 				   	   'icon' 			=> 'icon.htm',
					 				   	   'descr'			=> 'descr.htm',
					 				   	   'elem_file'		=> 'elem_file.htm',
					 				       'elem_folder'	=> 'elem_folder.htm'
									   	   ));
			$allow = array();
			$line = 0;
			for ( $n = 1; $n <= $info_rows; $n++ ) 
			{			
				$hash = $gData->FetchRow($info);
				if ( (strlen($hash[5]) > 0) || ($allow[$hash[0]] == 1) ) 
				{
					$allow[$hash[6]] = 1;

					if ( $hash[8] > 0 ) 
					{
						$tpl_sub->Assign('ID', $hash[0]);
						$tpl_sub->Parse('DESCR', 'descr');	
					}
					else 
					{
						$tpl_sub->Assign('DESCR', '');
					}					
					if ( $hash[4] == 1)
					{
						$tpl_sub->Assign(array('NAME'	=> htmlspecialchars($hash[1]),
										   	   'LEVEL'	=> $hash[2],
										   	   'LINE'	=> ( $line % 2 )
										   	   ));
						$tpl_sub->Parse('ELEMENT', 'elem_folder');
					}
					else 
					{
						$icon_exists = is_file('./files/info_value'.$hash[7].'.jpg');
						$value = htmlspecialchars($hash[5]);
						if ( strpos($hash[5], 'ftp://') !== false || strpos($hash[5], 'http://') !== false ) 
						{
							if ( strlen($value) > 30 ) $value = substr($value, 0, 30).'...';
							$value = '<a href="'.$hash[5].'" target=_blank>'.$value.'</a>';
						}						
						$tpl_sub->Assign(array('NAME'	=> htmlspecialchars($hash[1]),
			      	     	       		 	   'VALUE'	=> $value,
											   'LEVEL'	=> $hash[2],
											   'URL'	=> './files/info_value'.$hash[7].'.jpg',
											   'LINE'	=> ( $line % 2 )
											   ));
						if ( $icon_exists ) $tpl_sub->Parse('VALUE', ',icon');						
						$tpl_sub->Parse('ELEMENT', 'elem_file');
					}				
					$tpl_sub->Parse('UNIT', ',unit');
					$line++;
					if ( strlen($hash[3]) > 0 ) $gTpl->Assign($hash[3], $tpl_sub->Fetch('VALUE'));					
				}
			}
			if ( count($allow) > 0 ) 
			{
		    	$tpl_sub->Parse('MAIN', 'main');
				$info = $tpl_sub->Fetch('MAIN');
			}
			else
			{
				$info='';
			}
		}
		else
		{
			$info='';
		}
	}
	else
	{
		$info='';
	}

	
	// Make additional description
	$content = iconv('UTF-8', SHOP_CHARSET, implode("", (@file('./files/apendix'.$id.'.htm'))));
	$content = @eregi_replace("src=\"([^\"<>[:space:]]+)\"([<>[:space:]])", 'src="files/\\1"\\2', $content);
	$content = @eregi_replace('files\/http', 'http', $content);
	$content = @eregi_replace('ShowBigFoto\(\'', 'ShowBigFoto(\'files/', $content);
	$content = str_replace('{INFO}', $info, $content);	    	
	$gTpl->Assign('CONTENT', $content);
	
	// Parsing page properties
	$gTpl->Assign(array('TITLE'			=> htmlspecialchars($goods['name']),
					    'DESCRIPTION'	=> htmlspecialchars($goods['descr']),
					    'REDIRECT'		=> '',
					    'ID'			=> $id
					    ));		
	if ( !isset($_SESSION['client']) ) $gTpl->Parse('REDIRECT', 'redirect');
					   
	// Echo shop variables
	echo_shop_variables('in_techpage');

	// Parse main page
	$gTpl->Parse('MAIN', 'main');
	$gEndPoint = run_time($gStartPoint);
	$gTpl->FastPrint('MAIN');
	
	// Echo page compilate time
	echo_page_time($gEndPoint);
		
}


?>