<?php

/**
 * image_verify.php
 * ----------------
 * @version 5.4.0
 * @copyright 2002-2010 Melbis Company
 * @link http://www.melbis.com
 * @author Dmitriy Kasyanov
 **/

// Define script folder 
define('FOLDER', './');


// Variables
define('VERIFY_IMG_WIDTH', 150);
define('VERIFY_IMG_HEIGHT', 25);
 
 
// Require classes and includes
require_once('./admin/privat/privat.php');
require_once('./admin/includes/common.php'); 

// Start sessions
shop_session();
 
// Go!
if ( isset($_GET['verify_code']) )
{
	try_code();
}
else 
{
	make_image();
}

/**
 * Function make_image
 * Make image with secret code
 **/
function make_image()
{
 	header("Content-type: image/png");
	
 	// Start random
	list($usec, $sec) = explode(' ', microtime());
   	$random = (float) $sec + ((float) $usec * 100000);
   	srand($random); 	
 	
 	// Create image
	$img  = imagecreatetruecolor(VERIFY_IMG_WIDTH, VERIFY_IMG_HEIGHT);
    $bg_col = imagecolorallocate($img, 255, 255, 255);
    imagefilledrectangle($img, 0, 0, VERIFY_IMG_WIDTH, VERIFY_IMG_HEIGHT, $bg_col);
    
    
    // Paste count code
	for ( $i = 0; $i <= 5; $i++ ) 
	{	
		$img_num = imagecreatefromjpeg('./images/verify/'.$_SESSION['verify_code'][$i].'.jpg');
		$img_num_x = imagesx($img_num);
		$img_num_y = imagesy($img_num);
		$x = $i * 25 + rand(0, 5);
		$y = rand(0, 3);
		imagecopy($img, $img_num, $x, $y, 0, 0, $img_num_x, $img_num_y);
	}    
    
    // Load noise image
    $img_noise = imagecreatefrompng('./images/verify/noise.png');
 	$img_noise_x = imagesx($img_noise);
	$img_noise_y = imagesy($img_noise);
	
	// Copy noise
	for ( $i = 0; $i <= 5; $i++ ) 
	{
		$x = $i * 50 + rand(0, 10);
		$y = rand(0, 5);
		imagecopy($img, $img_noise, $x, $y, 0, 0, $img_noise_x, $img_noise_y);
	}

    // Output and destroy
	imagepng($img);
	imagedestroy($img);	 	
}

/**
 * Function try_code
 * Testing secret code
 **/
function try_code()
{
	if ( $_GET['verify_code']*1 == implode('', (array) $_SESSION['verify_code']) )
	{
		$result = 'right';	
	}
	else 
	{
		$result = 'wrong';
	}
	
	echo '<script> self.close(); window.opener.AlertCheck("'.$result.'"); </script>'; 
}

?>