<?php

/**
 * index.php
 * ---------
 * @version 5.4.0
 * @copyright 2002-2010 Melbis Company
 * @link http://www.melbis.com
 * @author Dmitriy Kasyanov
 **/

// Define script folder 
define('FOLDER', './');

// Hacking attempt variables
define('SERVER_NAME', $_SERVER["SERVER_NAME"]);
define('SERVER_ADDR', $_SERVER['SERVER_ADDR']);

// Require classes and includes
require_once('./admin/privat/privat.php');
require_once('./admin/includes/common.php');
require_once('./admin/includes/section.php');
require_once('./admin/includes/client.php');
require_once('./admin/includes/goods.php');
require_once('./admin/includes/basket.php');
require_once('./admin/includes/filter.php');
require_once('./admin/includes/partner.php');
require_once('./admin/includes/vote_blocks.php');
require_once('./admin/includes/news_blocks.php');
require_once('./admin/class/show/class.FastTemplate.php');

// Anti-Hacking test
if ( SERVER_NAME != $_SERVER["SERVER_NAME"] || SERVER_ADDR != $_SERVER['SERVER_ADDR'] ) die ('Hacking aborted! Don\'t change server name and ip!');

// Start sessions
shop_session();

// Go!
main();


/**
 * Function main
 **/
function main()
{
	global $gData, $gPage, $gOptions, $gTpl, $gStartPoint;

	// Get start point for time
	$gStartPoint = run_time(0);
	
	// Connect to Data 
	$gData = data_connect();	
	
	// Save Partner Jump
	if ( isset($_GET['partner']) ) save_partner_jump();

	// Get page properties
	$gPage = $gData->GetMainPageProperties();	
	
	// Define client
	if ( !isset($_SESSION['client']) )
	{
		new_client();
	}
	
	// Test for reload database
	if ( test_basket_reload() ) exit;
	
	// Make path for back
	make_back_path();
	
	// Save shop statistic
	save_shop_stat('index');
	
	// Init templates
	$gTpl = new FastTemplate('./'.TEMPLATES.'/_index');
	$gTpl->DefineTemplate(array('main' 			=> 'main.htm',
								'text_block'	=> 'text_block.htm'
								));
	
	// Parsing page properties
	$file_path = './files/topic'.$gPage['id'].'.htm';
	if ( is_file($file_path) ) 
	{ 
		$gTpl->Assign('CONTENT', iconv('UTF-8', SHOP_CHARSET, implode("", (@file($file_path)))));
		$gTpl->Parse('TEXTBLOCK', 'text_block');
		$gTpl->Clear('CONTENT');
	} 
	else 
	{ 
		$gTpl->Assign('TEXTBLOCK', '');
	}
	$gTpl->Assign(array('TITLE'			=> htmlspecialchars($gPage['title']),
					    'DESCRIPTION'	=> htmlspecialchars($gPage['descr']),
					    'KEYWORDS'		=> htmlspecialchars($gPage['keywords'])));

	// Parse sections list
	$gTpl->Assign(sections(0, true));

	// Parse advert goods
	$gTpl->Assign(advert_goods($gPage['id']));

	// Parse gift goods
	if ( ($_SESSION['client']['proc'] == 0) && ($_SESSION['client']['category_id'] == 0) ) 
	{
	    $gTpl->Assign('GIFTGOODS', gift_goods());
	}
	else 
	{
		$gTpl->Assign('GIFTGOODS', '');
	}
	

	// Parse discount goods
	if ( ($_SESSION['client']['proc'] == 0) && ($_SESSION['client']['category_id'] == 0) ) 
	{
		$gTpl->Assign('DISCOUNTGOODS', discount_goods());
	}
	else 
	{
		$gTpl->Assign('DISCOUNTGOODS', '');
	}
	
	// Parse new goods
	$gTpl->Assign('NEWGOODS', new_goods());

	// Parse hit goods
	$gTpl->Assign('HITGOODS', hit_goods($gOptions['index_hit_col'], $gOptions['index_hit_how']));

	// Parse filters
	$gTpl->Assign(filters('index', 'dir.php?search_words='));	

	// Parse news
	$gTpl->Assign(news_blocks());
	
	// Parse voting
	$gTpl->Assign(vote_blocks());
	
	// Echo shop variables
	echo_shop_variables('in_firstpage');
	
	// Additional modules
	use_php_mod('index');
	
	// Parse main page
	$gTpl->Parse('MAIN', 'main');
	$gEndPoint = run_time($gStartPoint);
	$gTpl->FastPrint('MAIN');
	
	// Echo page compilate time
	echo_page_time($gEndPoint);
		
}


?>