<?php

/**
 * order_view.php
 * --------------
 * @version 5.4.0
 * @copyright 2002-2010 Melbis Company
 * @link http://www.melbis.com
 * @author Dmitriy Kasyanov
 **/

// Define script folder 
define('FOLDER', './');

 
// Require classes and includes
require_once('./admin/privat/privat.php');
require_once('./admin/includes/common.php');
require_once('./admin/includes/basket.php');
require_once('./admin/class/show/class.FastTemplate.php');


// Start sessions
session_name(DB_NICK."_MSSADMIN");
session_start();

// Go!
main();


/**
 * Function main
 **/
function main()
{
	global $gData, $gTpl, $gOptions;

	// Get start point for time
	$gStartPoint = run_time(0);
	
	// Connect to Data 
	$gData = data_connect();	

	
	$order_id = $_GET['order_id']*1;
	$order_sid = addslashes($_GET['order_sid']);
	$order = $gData->GetArchiveOrder($order_id);	
	if ( ( $order['sid'] != $order_sid ) || ( strlen($order_sid) == 0 ) ) shop_die('no_found_order', $order_sid.$order_id, __LINE__, $_SERVER['REQUEST_URI']);
	$order_status = $order['status'];
	$order_payment = $order['get_payment'];		

	// Can pay this order?
	if ( $order['status'] == 0 )
	{
		$payment = $gData->GetPaymentValue($order['payment_id']);
		$rows = $gData->GetNumRows($payment);
		if ( $rows > 0 ) 
		{
			$hash = $gData->FetchHash($payment);			
			$can_payment = ( $hash['online'] == 1 );
		}
		else 
		{
			$can_payment = false;
		}
	}
	else 
	{
		$can_payment = ( $order['status'] == 1 );
	}	
	
	// Start make order review
	$templ_path = './'.TEMPLATES.'/_order_view';
	$its_operator = false;
	if ( strlen($_SESSION['login']) > 0 ) 
	{
		$templ_path = './admin/templates/'.$_SESSION['templ'].'/_order_view';
		$its_operator = true;
	}
	
	// Init templates
	$gTpl = new FastTemplate($templ_path);
	$gTpl->DefineTemplate(array('main'			=> 'main.htm',
							    'unit'			=> 'unit.htm',
							    'unit_gift'		=> 'unit_gift.htm',
							    'status0'		=> 'status0.htm',
							    'status1'		=> 'status1.htm',
							    'status2'		=> 'status2.htm',
							    'status3'		=> 'status3.htm',
							    'order_status0'	=> 'order_status0.htm',
							    'order_status1'	=> 'order_status1.htm',
							    'order_status2'	=> 'order_status2.htm',
							    'order_status3'	=> 'order_status3.htm',
							    'order_status4'	=> 'order_status4.htm',
							    'order_payment1'=> 'order_payment1.htm',
							    'order_payment2'=> 'order_payment2.htm',
							    'client_unit'	=> 'client/unit.htm',
							    'elem_file'		=> 'client/elem_file.htm',
							    'elem_folder'	=> 'client/elem_folder.htm',
							    'condition'		=> 'condition.htm',
							    'delivery'		=> 'delivery.htm',
							    'invoice'		=> 'invoice.htm'
							    ));
	if ( $its_operator ) 
	{
		$gTpl->DefineTemplate(array('set_status0'	=> 'set_status0.htm',
								    'set_status1'	=> 'set_status1.htm',
								    'set_status2'	=> 'set_status2.htm',
								    'set_status3'	=> 'set_status3.htm',
								    'set_status4'	=> 'set_status4.htm',
								    'set_payment0'	=> 'set_payment0.htm',								    
								    'set_payment1'	=> 'set_payment1.htm',
								    'set_payment2'	=> 'set_payment2.htm',
								    'unit_part'		=> 'unit_part.htm',
								    'partner'		=> 'partner.htm'
								    ));
	}
							    

	// Parse fields tree client
	$client_sth = $gData->GetArchiveClientField($order['id']);
	$rows = $gData->GetNumRows($client_sth);
	$gTpl->Assign('CLUNIT', '');	
	$allow = array();
	for ( $n = 1; $n <= $rows; $n++ ) 
	{			
		$hash = $gData->FetchHash($client_sth);
		if ( $n == 1 ) $gTpl->Assign('LOGIN', htmlspecialchars($hash['value_text']));
		if ( $n == 2 ) $gTpl->Assign('EMAIL', htmlspecialchars($hash['value_text']));
		if ( $n < 4 ) continue;
		$gTpl->Assign('NAME', htmlspecialchars($hash['name']));
		$gTpl->Assign(array('NAME'	=> htmlspecialchars($hash['name']),
						    'LEVEL'	=> $hash['tlevel']
							));		
		if ( $hash['isfolder'] == 1) 
		{
			$gTpl->Parse('ELEMENT', 'elem_folder');
		}
		else
		{
			$gTpl->Assign('VALUE', htmlspecialchars($hash['value_text']));
			$gTpl->Parse('ELEMENT', 'elem_file');
		}
		$gTpl->Parse('CLUNIT', '.client_unit');
	}
	
	// Get Goods list
	$goods = $gData->GetArchiveGoods($order['id']);
	$rows = $gData->GetNumRows($goods);
    // Parse goods
	for ( $i = 1; $i <= $rows; $i++ ) 
	{			
		$hash = $gData->FetchHash($goods);
		$disc_suma = $hash['price'] - $hash['new_price']; 
		$gTpl->Assign(array('NAME'  	=> htmlspecialchars($hash['name']),
						    'MEAS'		=> htmlspecialchars($hash['meas']),
						    'CODE'		=> htmlspecialchars($hash['code']),
						    'KIT'		=> htmlspecialchars($hash['param_name']),
						    'PRICE'		=> number_format($hash['price'], $gOptions['main_prec'], "," ,"'"),
						    'NEWPRICE'	=> number_format($hash['new_price'], $gOptions['main_prec'], "," ,"'"),
						    'DISCSUMA'	=> number_format($disc_suma, $gOptions['main_prec'], "," ,"'"),
						    'SUMASEL'	=> ( $disc_suma != 0 ) ? '1' : '0',
						    'ITOGO'		=> number_format($hash['how']*$hash['new_price'], $gOptions['main_prec'], "," ,"'"),
		   				    'HOW' 		=> $hash['how'],
						    'ID'		=> $hash['id'],
						    'STOREID'	=> $hash['store_id'],
						    'NOTE'		=> ''
       			            ));			
		$gTpl->Parse('STATUS', 'status'.$hash['status']);
		if ( $hash['status'] == 10 )
		{
			$gTpl->Parse('UNIT', '.unit_gift');
		}
		else 
		{
			$gTpl->Parse('UNIT', '.unit');
		}
		// Operate order
		if ( $its_operator && $hash['status'] != 10 && $order['partner_id'] > 0 )
		{
			$gTpl->Assign(array('PARTPROC' 	=> number_format($hash['part_proc'], 2, "," ,"'"),
							    'PARTVALUE'	=> number_format($hash['part_value'], $gOptions['main_prec'], "," ,"'"),
							    'PARTSUM'	=> number_format($hash['part_proc']*$hash['price']/100, $gOptions['main_prec'], "," ,"'"),
							    'DISCSUM'	=> number_format($hash['price']-$hash['new_price'], $gOptions['main_prec'], "," ,"'"),
							    'PARTITOGO'	=> number_format($hash['how']*$hash['part_value'], $gOptions['main_prec'], "," ,"'")
       			    	        ));				
			$gTpl->Parse('PARTUNIT', '.unit_part');
		}	
	}
	// Delivery
	if ( $order['deliv_cost'] > 0 ||  strlen($order['deliv_name']) > 0 )
	{
		$gTpl->Assign(array('COST'	=> number_format($order['deliv_cost'], $gOptions['main_prec'], "," ,"'"),
						    'NAME'	=> htmlspecialchars($order['deliv_name'])
						    ));
		$gTpl->Parse('DELIVERY', 'delivery');
	}	
	else
	{
		$gTpl->Assign('DELIVERY', '');
	}
	// Condition
	if ( $order['cond_cost'] ) 
	{
		$gTpl->Assign(array('COST'	=> number_format($order['cond_cost'], $gOptions['main_prec'], "," ,"'"),
						    'NAME'	=> htmlspecialchars($order['cond_name'])
						    ));
		$gTpl->Parse('CONDITION', 'condition');
	}	
	else
	{
		$gTpl->Assign('CONDITION', '');
	}	
	// Payment
	$gTpl->Assign(array('PAYCOST'	=> number_format($order['payment_cost'], 2, "," ,"'"),
					    'PAYNAME'	=> htmlspecialchars($order['payment_name']),
					    'PAYCURR'	=> htmlspecialchars($order['payment_curr']),
					   ));
	$gTpl->Assign(array('ITOGOSUM'	=> number_format($order['itogo_sum'], $gOptions['main_prec'], "," ,"'"),
					    'DISCSUM'	=> number_format($order['disc_sum'], $gOptions['main_prec'], "," ,"'"),
					    'DISCSEL'	=> ($order['disc_sum'] != 0) ? '1' : '0',
					    'TOTALSUM'	=> number_format($order['total_sum'], $gOptions['main_prec'], "," ,"'")
						));
	// Operate order
	if ( $its_operator && $order['partner_id'] > 0 )
	{
		$partner = $gData->GetPartner($order['partner_id']);
		$gTpl->Assign(array('PARTID' 		=> $order['partner_id'],
						    'PARTLOGIN'		=> htmlspecialchars($partner['login']),
						    'PARTTOTALSUM'	=> number_format($order['partner_sum'], $gOptions['main_prec'], "," ,"'")
       		    	        ));			
		$gTpl->Parse('PARTNER', '.partner');
	}	
	else 
	{
		$gTpl->Assign('PARTNER', '');
	}					

	$gTpl->Parse('ORDERSTATUS', 'order_status'.$order_status);
	$gTpl->Parse('ORDERPAYMENT', 'order_payment'.$order_payment);
	$gTpl->Assign(array('TEMPLATES'		=> TEMPLATES,
						'CURR'			=> htmlspecialchars($gOptions['main_base_curr']),
						'NOTICE'		=> nl2br(htmlspecialchars($order['notice'])),
						'INSIDENOTE'	=> htmlspecialchars($order['inside_note']),
					    'ORDERCODE'		=> htmlspecialchars($order['code']),
					    'DATETIME'		=> date($gOptions['main_fmt_date_time'], strtotime($order['date_time'])),
					    'CHARSET'		=> SHOP_CHARSET,
					    'ORDERID'		=> $order_id,
					    'ORDERSID'		=> $order_sid,
					    'INVOICE'		=> ''
					    ));
	if ( $can_payment ) $gTpl->Parse('INVOICE', 'invoice');					    
	if ( $its_operator ) 
	{					    
		$gTpl->Parse('OPTIONSTATUS', 'set_status'.$order_status);
		$gTpl->Parse('OPTIONPAYMENT', 'set_payment'.$order_payment);
	}
						
	$gTpl->Parse('MAIN', 'main');
	$gEndPoint = run_time($gStartPoint);
	$gTpl->FastPrint('MAIN');
	
	// Echo page compilate time
	echo_page_time($gEndPoint);

}						


?>