<?php

/**
 * param.php
 * ---------
 * @version 5.4.0
 * @copyright 2002-2010 Melbis Company
 * @link http://www.melbis.com
 * @author Dmitriy Kasyanov
 **/

// Define script folder 
define('FOLDER', './');

 
// Require classes and includes
require_once('./admin/privat/privat.php');
require_once('./admin/includes/common.php');
require_once('./admin/includes/goods.php');
require_once('./admin/class/show/class.FastTemplate.php');

// Start sessions
shop_session();

// Go!
main();


/**
 * Function main
 **/
function main()
{
	global $gData, $gOptions, $gTpl, $gStartPoint;

	// Get start point for time
	$gStartPoint = run_time(0);
	
	// Connect to Data 
	$gData = data_connect();	

	// Get and test properties
	if ( !isset($_GET['store_id']) || !isset($_GET['param_id']) || !isset($_SESSION['client']) )
	{ 
	 		header("Location: ./");  
	 		exit; 
	}
	$param_id = $_GET['param_id']*1;
	$store_id = $_GET['store_id']*1;
	
	// Define info currency
	if ($_SESSION['payment']['multiplex']*1 > 0) 
	{
	    $gOptions['main_base_curr'] = $_SESSION['payment']['curr_name'];
		$gOptions['main_prec'] = $_SESSION['payment']['curr_prec'];
	}	

	// Get Param options
	$param = $gData->GetParam($param_id);
	if ( $param['id'] == 0 ) shop_die('no_goods_param', $param['id'], __LINE__, $_SERVER['REQUEST_URI']);
	
	// Get Goods options
	$goods = $gData->GetGoods($store_id);
	if ( $goods['id'] == 0 ) shop_die('no_goods', $goods['id'], __LINE__, $_SERVER['REQUEST_URI']);
	
	
	// Init templates
	$gTpl = new FastTemplate('./'.TEMPLATES.'/param');
	$gTpl->DefineTemplate(array('main' 			=> $param[dir_name].'/main.htm',
							    'unit' 			=> $param[dir_name].'/unit.htm',
							    'order' 		=> $param[dir_name].'/order.htm',
							    'between_row'	=> $param[dir_name].'/between_row.htm',
							    'status0' 		=> $param[dir_name].'/status0.htm',
							    'status1' 		=> $param[dir_name].'/status1.htm',
							    'status2' 		=> $param[dir_name].'/status2.htm',
							    'status3' 		=> $param[dir_name].'/status3.htm'
							    ));
	
	// Calc prices
	$ic_value = $_SESSION['payment']['multiplex']*1;
	list($new_price, $disc_proc, $disc_suma, $price_offer) = calc_goods_price($goods['id'], $goods['price'], $goods['disc_price']);
	$price = $goods['price'];
	$left_sum = $price - $new_price;	
	
	// Echo param values
	$values = $gData->GetParamGoodsValues($store_id, $param_id, $goods['how']);
	$rows = $gData->GetNumRows($values);
	$col_cnt = 1;
	for ( $i = 1; $i <= $rows; $i++ )
	{
		$hash = $gData->FetchRow($values);
		if ( ($col_cnt == $param['col_num']) && ($i <> $rows) ) 
		{
			$gTpl->Parse('BETWEENROW', 'between_row');  
			$col_cnt = 1; 
		} 
		else 
		{ 
			$gTpl->Assign('BETWEENROW', ''); 
			$col_cnt += 1; 
		}
		if ( is_file('./files/param_value'.$hash[0].'.jpg') ) 
		{
		    $img_file = 'files/param_value'.$hash[0].'.jpg';
		} 
		else
		{
			$img_file = 'files/param_value_default.jpg';
		}		
		if ( strlen($hash[5]) > 0 )
		{
			// Special fixed price for "real goods" or add price for "modification"
			if ( $param['phis_type'] == 0 ) 
			{
				// Phis type of param is "real goods"
				$add_price = round($hash[5]*(1-$disc_proc/100), 2) - ($disc_suma+$new_price);
			}
			else 
			{
				// Phis type of param is "modification"
				$add_price = $hash[5];
				$add_price = round($add_price*(1-$disc_proc/100), 2);
			}			
		}
		else 
		{
			// Price calc with proc and sum
			if ( $param['phis_type'] == 0 )
			{
				// Phis type of param is "real goods"
				$param_price = round($price*(1+$hash[3]/100), 2)+$hash[4];
				$add_price = round($param_price*(1-$disc_proc/100), 2) - ($disc_suma+$new_price);
			}
			else 
			{
				// Phis type of param is "modification"
				$add_price = round($price*$hash[3]/100, 2)+$hash[4];
				$add_price = round($add_price*(1-$disc_proc/100), 2);
			}			
		}
		$sum_price = $new_price + $add_price;
		$sign = '';
		if ( $add_price >= 0 ) $sign = '+';
		if ( $ic_value > 0 ) 
		{
			$add_price = round($add_price*$ic_value, 2);
			$sum_price = round($sum_price*$ic_value, 2);
		}			
		if ( strlen($hash[5]) > 0 ) 
		{
		    $status = $hash[7];
			$code = $hash[6];
			$how = $hash[8];
		}
		else
		{
			$status = $goods['status'];
			$code = $goods['code'];
			$how = $goods['how'];
		}
		$gTpl->Parse('STATUS', 'status'.$status);
		$gTpl->Assign(array('NAME'	     	=> htmlspecialchars($hash[1]),
						    'CODE'			=> htmlspecialchars($code),
				   		    'VALUEID' 		=> $hash[0],
						    'DESCR'			=> $hash[2],
						    'ICON'			=> $img_file,
						    'ADDPRICE'		=> $sign.number_format($add_price, $gOptions['main_prec'], "," ,"'"),
						    'SUMPRICE'		=> number_format($sum_price, $gOptions['main_prec'], "," ,"'"),
						    'CALCPRICE'		=> number_format($sum_price, $gOptions['main_prec'], "." ,""),
						    'HOW'			=> $how
	        	            ));
		( $status == 1 ) ? $gTpl->Assign('ORDER', '') : $gTpl->Parse('ORDER', 'order');
		$gTpl->Parse('UNIT', '.unit');						   		
	}
	
	// Info currency
	if ( $ic_value > 0 ) $new_price = round($new_price*$ic_value, 2);
		
	// Assign base vars
	$gTpl->Assign(array('PARAMNAME'		=>	htmlspecialchars($param['name']),
	                    'GOODSNAME'    	=>	htmlspecialchars($goods['name']),
			  		    'PRICE'			=>  number_format($new_price, $gOptions['main_prec'], ",", "'"),
		           	    'PARAMID'		=>	$param_id,
		                'STOREID'		=>	$store_id,
		                'COLSPAN' 		=> 	$param['col_num']
		                ));
	

	// Parsing page properties
	$gTpl->Assign(array('TITLE'			=> htmlspecialchars($param['name']),
					    'DESCRIPTION'	=> ''
					    ));	
	
	// Echo shop variables
	echo_shop_variables('in_techpage');	
	
	// Parse main page
	$gTpl->Parse('MAIN', 'main');
	$gEndPoint = run_time($gStartPoint);
	$gTpl->FastPrint('MAIN');
	
	// Echo page compilate time
	echo_page_time($gEndPoint);
		
}


?>